;;
;; Beebris - Atari ST / The Law 1991 (Bad Brew Crew) - Featured in Apathetic Games
;;
;; Beebris Tribute - Jaguar / Cyrano Jones 2009 (Reboot)
;;
;; Hugely inneficient with memory useage (32k files with 6 8*8 blocks in them!)
;; but ported in around a week.
;;
;; Original ST code available on the D-Bug website (http://www.dbug-automation.co.uk)
;; Jaguar code available on the Reboot website (http://reboot.dbug-automaiton.co.uk)
;;
;; This code is far from optimised, or even readable. I would recommend not using it
;; for educational purposes.  The Jaguar changes really are "hacks" to make it run,
;; and there is nothing elegant or even nice in here worth examining above and beyond
;; the original ST version.
;;
;; (c) 1991 The Law / BBC
;; (c) 2009 Reboot
;;

ob_list			equ	$1f0000
ob_list1		equ	$1f8000
objs			equ 30

				.include	"JAGUAR.INC"
		
				.text

				lea	$1e0000,a7
		
                move.w  #$2700,sr               			; kill interupts
				move.w	#%0000011011000111,VMODE			; 320x256!!

				lea		screen_obj,a0
				lea		scr_ram_end,a1
.killram:		clr.w	(a0)+
				cmp.l	a0,a1
				bne.s	.killram
				
                jsr     InitVideo               			; Setup our video registers.
				jsr		Init_music
				
				jsr		intro_seq

                move.l  #null_list,d0
                swap    d0
                move.l  d0,OLP 
				
				bsr     MakeObjectList          			; Create bit magled list for OP

                move.l  #vbl,LEVEL0     					; Install 68K LEVEL0 handler
                move.w  a_vde,d0                			; Must be ODD
                sub.w   #16,d0
                ori.w   #1,d0
                move.w  d0,VI

                move.w  #1,INT1                 			; Enable video interrupts
                and.w   #$f8ff,sr		
 
				bra		code
				
VB_INTERUPT:	add.w	#1,vbl_done
				move.w  #$101,INT1              			; Signal we're done
                move.w  #$0,INT2
                rte	
				
				.dphrase
null_list:		dc.l	0,4
			
code:
		move.l	backdrop_obj,a0
		move.l	#-8,d0
		move.l	#18,d1
		
		move.w	CONFIG,d6
		andi.w	#VIDTYPE,d6
		beq		.pal
.ntsc:	add.l	#7,d1
.pal:	bsr		setup_object_xy

		lea		$f00400,a0		; black screen
		lea		wellpic+2,a1
		move.l	#15,d7
.makeb:
		move.w	(a1)+,(a0)+
		dbra	d7,.makeb
		move.l	#15,d7
		lea		copyrite+2,a1
.makec:
		move.w	(a1)+,(a0)+
		dbra	d7,.makec
		
		lea 	hiscreen,a0		; address of screen #1
		move.l 	a0,screen1
		sub.l 	#$10000,a0			; sub a few bytes
		move.l 	a0,screen2			; address of screen #2

		move.l 	screen1,bot1		; calc address of lower borders
		move.l 	screen2,bot2
		move.l 	#200*160,d0
		add.l 	d0,bot1
		add.l 	d0,bot2

		lea 	-8*160(a0),a0		; 'bounce' area!
wipe:	clr.w 	(a0)+				; and clear out RAM
		cmp.l 	#scr_ram_end,a0		; 
		bne.s 	wipe  
		
		bsr 	make_num_table		; make a table for the scores

;
; INIT MUSIC HERE
;
	
		bsr 	place_panel			; and draw the score panel

		bsr 	place_well_grafix	; and the well

		bsr 	credits

		lea 	copybitmap,a0		; (c) copyright crap
		move.l 	screen1,a1
		move.l 	screen2,a2
		add.l 	#204*160,a1
		add.l 	#204*160,a2
		move.l 	#(26*160)/4,d0
.dcpy:	move.l 	(a0),(a1)+
		move.l 	(a0)+,(a2)+
		subq.l 	#1,d0
		bne.s 	.dcpy

				bsr		frame_wait
                move.l  #ob_list,d0
                swap    d0
                move.l  d0,OLP                  			; Object Processor is GO!

		
************************************************************************
*     Only run once per game, and that is right at the beginning!      *
************************************************************************

reset:	bsr 	place_well_grafix	; refresh the well
		move.w 	#0,start_y			; level 0 height    (junked!!)
		move.l 	#20,start_offset	; screen offset     (junked!!)
		move.w 	#'00',score-2		; clear score
		move.l 	#'0000',score		; clear score
		move.w 	#'00',level			; clear level
		move.w 	#3,c_down
		move.l 	#11,levspd			; reset speed to 11 (junked!!)
		move.w 	#0,lines_done		; and no lines made
		
		lea 	score_pic+34+(147*160),a0	; "Push Space To Play"
		bsr 	line_out

		lea 	score-2,a0			; send score to screen
		move.l 	#56+(160*128),a1	
		move.l 	a1,a2
		bsr 	print_number

		lea 	level,a0			; send level number to screen
		move.l 	#104+(160*88),a1
		move.l 	a1,a2
		bsr 	print_number

		bsr 	init_level			; game setup options

		moveq.l #0,d0				; get the NEXT shape
		move.w 	random_piece,d0
		add 	d0,d0
		add 	d0,d0
		lea 	piece_table,a0
		move.l 	(a0,d0),next_shape

		lea 	score_pic+34+(174*160),a0	; Nothing (clear line)
		bsr 	line_out

*************************************************************************
*   We get back here every time a piece hits the bottom of the well..   *
*************************************************************************

next_piece:

		bsr 	frame_wait

		bsr 	check_overflow_score	; has score overflowed?
		bsr 	frame_wait				; v-sync

		lea 	score-2,a0				; lets update the scrore
		move.l 	#56+(160*128),a1		; screen address to print
		move.l 	a1,a2
		bsr 	print_number

		bsr 	frame_wait				; v-sync

		lea 	level,a0				; lets update the level
		move.l 	#104+(160*88),a1	
		move.l 	a1,a2
		bsr 	print_number

		cmp.l 	#'arca',arcade
		bne.s 	.again
		subq.w 	#1,c_down
		bpl.s 	.again
		move.w 	#3,c_down
		bsr 	which_arcade_bitz	

.again:	move.l 	levspd,xspeed			; reset current speed
		move.w 	#0,drops				; lines dropped this piece
		move.l 	#4,next_add				; used with MOVEP offsets
		move.l 	#4,next_sub				; used with MOVEP offsets
		move.l 	#40000,wibble			; area 'between' screens!
		move.l 	start_offset,address_offset	; address to draw shape at
		move.w 	#0,current_rot			; 1st rotaton
		move.w 	#5,well_x				; starts at 6 accross
		move.w 	start_y,well_y			; and y down into well
		bsr 	grab_piece				; fetch from database

		move.w 	xspeed+2,around			; init game speed delay

		move.l 	first_rotate,a1			; get co-ords of piece
		bsr 	test_positions			; check top of well
		bmi 	game_over				; branch if no space

		bsr 	frame_wait
		bsr 	display_next				; copy next to screen

**************************************************************************
*  This is done every time a piece drops one square....................  *
**************************************************************************

mainloop:
		cmp.b 	#$01,lastkey			; esc - abort current game
		beq 	game_over

		cmp.l 	#1,xspeed				; fastdrop?
		bne 	wait
		addq.w 	#1,drphgt				; fast drop counter
		move.w 	#1,around

		cmp.w 	#'40',level
		beq.s 	kippers

wait:	move.l 	xspeed,d0				; this loop controls the game speed
		asr 	d0
waitb:	bsr 	frame_wait
		dbra d0,waitb

kippers:
		bsr 	move_em					; update block
		bsr 	scan_keyboard			; player moved?
		bsr 	unplot_block			; erase old block
		bsr 	plot_block				; and plot the current one
		bsr 	swap_em					; swap screens

		cmp.w 	#'40',level
		beq.s 	skipp2

		subq.w 	#1,around
		bne.s 	mainloop

skipp2:	move.w 	xspeed+2,around			; game speed re-init

		lea 	chk1,a1					; has it hit something below?
		bsr 	test_positions
		bmi 	place					; branch if hit!

		addq.w 	#1,drops				; now increment drop counter
		bsr 	increment_verticals		; and adjust the table pointers

		bra 	mainloop				; then loop around

around:	dc.w 3							; moves allowed per drop
c_down:	dc.w 3							; drops till next arcade active!
mode:	dc.l 0

which_arcade_bitz:
		bsr 	get_arcade_level
		cmp.l 	#'_up_',mode
		beq 	shift_up
		cmp.l 	#'rand',mode
		beq 	random_block	
		rts
		
shift_up:
		bsr 	move_em
		bsr 	frame_wait
		move.l 	screen2,a1
		lea 	-160*8(a1),a0
		move.w 	#184,ctr
.loop1:	movem.l (a1),d0-d7/a2-a5
		movem.l d0-d7/a2-a5,(a0)
		lea 	160(a0),a0
		lea 	160(a1),a1
		subq.w 	#1,ctr
		bne.s 	.loop1
		move.w 	#8,ctr
		move.l 	screen2,a1
		lea 	-8*160(a1),a1
.loop2:	movem.l (a1),d0-d7/a2-a5
		movem.l d0-d7/a2-a5,(a0)
		lea 	160(a0),a0
		lea 	160(a1),a1
		subq.w 	#1,ctr
		bne.s 	.loop2
		bsr 	frame_wait
		bsr 	swap_em
		bsr 	ascii_up
		bsr 	frame_wait
		addq.w 	#1,up_word
		cmp.w 	#10,up_word
		bne.s 	.ok
		clr.w 	up_word
.ok:	moveq.l #0,d0
		move.w 	up_word,d0
		add.w 	d0,d0
		add.w 	d0,d0
		lea 	up_tabl,a0			; get new line for bottom of well!
		add.l 	d0,a0
		bsr 	arc_up
		rts
		
ascii_up:
		lea 	well,a0
		lea 	well_bot,a1
.move:	move.b 	12(a0),(a0)+
		cmp.l 	a0,a1
		bne.s 	.move
		rts
		
ctr:	dc.w 0

random_block:
		bsr 	frame_wait
		moveq.l #0,d3
		move.w 	rand_y,d0
		move.w 	rand_x,d1
		move.w 	x_off,d2
		lea 	well,a0
		move.w 	d0,d3
		mulu 	#12,d3
		add.w 	d3,a0
		add.w 	d1,a0
		cmp.b 	#'*',(a0)
		beq 	.rts
		move.b 	#'*',(a0)
		move.w 	d0,d3
		mulu 	#160*8,d3
		add.w 	d2,d3
		move.l 	screen1,a0
		move.l 	screen2,a1
		add.w 	d3,a0
		add.w 	d3,a1
		move.l 	new_colour,a4
		move.l 	(a4)+,a5
		cmp.l 	#-1,a5
		bne.s 	.ok
		lea 	pcol,a4
		move.l 	(a4)+,a5
.ok:	move.l 	a4,new_colour

		move.l	0*160(a5),d0
		move.l	d0,0*160(a0)
		move.l	d0,0*160(a1)
		move.l	1*160(a5),d0
		move.l	d0,1*160(a0)
		move.l	d0,1*160(a1)
		move.l	2*160(a5),d0
		move.l	d0,2*160(a0)
		move.l	d0,2*160(a1)
		move.l	3*160(a5),d0
		move.l	d0,3*160(a0)
		move.l	d0,3*160(a1)
		move.l	4*160(a5),d0
		move.l	d0,4*160(a0)
		move.l	d0,4*160(a1)
		move.l	5*160(a5),d0
		move.l	d0,5*160(a0)
		move.l	d0,5*160(a1)
		move.l	6*160(a5),d0
		move.l	d0,6*160(a0)
		move.l	d0,6*160(a1)
		move.l	7*160(a5),d0
		move.l	d0,7*160(a0)
		move.l	d0,7*160(a1)

.rts:	rts

new_colour:	dc.l pcol
pcol:		dc.l wellpic+34+136
			dc.l wellpic+34+140
			dc.l wellpic+34+144
			dc.l wellpic+34+148
			dc.l wellpic+34+152
			dc.l wellpic+34+156
			dc.l -1

rand_x:		dc.w 1
rand_y:		dc.w 10
x_off:		dc.w 4
next_x:		dc.w 4
next_x1:	dc.w 4

************************************************************************
*                      Routine to wait for one vbl.                    *
************************************************************************

frame_wait:
		move.w 	d0,-(a7)
		move.w 	vbl_done,d0	
blob:	cmp.w 	vbl_done,d0	
		beq.s 	blob
		move.w 	(a7)+,d0
		rts

**********************************************************************
*   Beebris game subroutines follow (and there are a lot of them!)   *
**********************************************************************

place:
		move.w 	#1,line_dn	; set flag to +ve
		tst.w 	drops		; is this first drop?
		beq 	game_over		; branch if yes to game over routines

		bsr 	bomb_line		; check to see if a bomb was dropped!
				; (beebris+ version only!)
		bsr 	plot_well		; plot the shape into the ascii map
		
		bsr 	check_for_line	; check for any lines made

		addq.l 	#1,score		; add one to score
		bsr 	check_overflow_score

		tst.w 	drphgt		; on a fast drop?
		beq 	anyline

		moveq.l #0,d0
		move.w 	drphgt,d0	; height dropped at fast speed
		clr.w 	drphgt		; then clear it
		add 	d0,d0		; mult by 2
addum:	addq.l 	#1,score		; add 1
		bsr 	check_overflow_score
		subq.w 	#1,d0	
		bne.s 	addum

anyline:
		tst.w 	line_dn		; now test the flag
		bmi 	levchk		; and branch if a line is made
		bra 	next_piece		; go get another piece

levchk:	moveq.l #0,d0		; add correct score for No. lines made
		move.w 	current_drops,d0	; number of lines made last block
		add 	d0,d0
		lea 	scoretab,a0		; get score
		move.w 	(a0,d0),d0
		cmp.w 	#200,d0		; 4 lines made?
		bne 	addit

;; play fanfare sample
;;
				movem.l	d0-a6,-(a7)
				move.l	#ooh,a0
				lea		$0,a1
				move.l	#9630,d0					; sample length
				moveq	#0,d1						; looplength (unlooped)
				moveq	#10,d2						; priority (high)
				move.l	#240,d3						; volume
				moveq	#0,d4						; freq
				jsr		musicplayer+$c
				
				move.l	#50,d7
.waiter:		bsr		frame_wait
				dbra	d7,.waiter
				
				movem.l	(a7)+,d0-a6

addit:	addq.l 	#1,score
		bsr 	check_overflow_score
		subq.w 	#1,d0
		bne.s 	addit

		bsr 	frame_wait

		cmp.w 	#10,lines_done	; have 10 lines been made?
		blt 	next_piece		; branch if not

		move.w 	#0,lines_done	; reset line counter

;; play jingle sample
;;
				movem.l	d0-a6,-(a7)
				move.l	#yeah,a0
				lea		$0,a1
				move.l	#11720,d0					; sample length
				moveq	#0,d1						; looplength (unlooped)
				moveq	#10,d2						; priority (high)
				move.l	#240,d3						; volume
				moveq	#0,d4						; freq
				jsr		musicplayer+$c
				
				move.l	#50,d7
.waiter:		bsr		frame_wait
				dbra	d7,.waiter
				
				movem.l	(a7)+,d0-a6


uplev:	move.w 	#3,c_down
		cmp.w 	#'40',level	; top level?
		beq 	next_piece

		addq.w 	#1,level		; and increment the level
		bsr 	check_overflow_level	; level number overflowed?
************************************************************************
		bsr 	res_lev		; reset all values

		cmp.l 	#'arca',arcade	; arcade mode enabled?
		bne.s 	.norm
		bsr 	get_arcade_level	; yes, check for new well data
		bsr 	process_level
.norm:	bra 	next_piece

res_lev:
		bsr.s 	conv		; convert ascii level to value
		bsr.s 	res_1		; get level speed/height data
		rts

conv:	moveq.l #0,d0
		move.b 	level,d0			; get first digit
		sub.b 	#'0',d0			; convert from ascii
		mulu 	#10,d0			; mult by 10
		moveq.l #0,d1
		move.b 	level+1,d1		; get second digit
		sub.b 	#'0',d1			; convert from ascii
		add.l 	d1,d0			; add to first
		rts

res_1:	mulu 	#12,d0			; mult total by 12
		lea 	lev_table,a0		; lookup table for level values
		move.l 	(a0,d0),levspd		; game speed
		move.w 	6(a0,d0),start_y		; ascii map offset
		move.l 	8(a0,d0),start_offset	; screen offset
		rts

arcade:	dc.l 0			; flag for 'arca'de mode
get_arcade_level:
		bsr 	conv		; get level number in d0
		lea 	arc_tab(pc),a0
		add 	d0,d0
		add 	d0,d0
		add 	d0,d0
		add.l 	d0,a0	
		move.l 	(a0)+,d0
		move.l 	d0,mode
		rts

empty:
		bsr 	place_well_grafix	; no data, wipe old well
		lea 	well,a0		
		move.l 	#23,d0		
.wipe:	clr.b 	1(a0)
		clr.l 	2(a0)
		clr.l 	6(a0)
		clr.b 	10(a0)
		lea 	12(a0),a0
		subq.l 	#1,d0
		bne.s 	.wipe
		rts

process_level:
		movem.l d0/a0,-(a7)	; clear the well out (screen & ascii)
		bsr 	empty
		movem.l (a7)+,d0/a0
		cmp.l 	#'grid',mode
		bne 	_rts
arc_up:	bsr 	move_em
		move.l 	(a0)+,a1		; get address of level data
.loop:	move.w 	(a1)+,d1		; height to place line data
		cmp.w 	#-1,d1			; end of data
		beq 	.rts
		move.w 	d1,-(a7)		; save for laters....
		lea 	well,a0		; address of ascii map
		mulu 	#12,d1		; and mult by 12 to get offset
		add.w 	d1,a0		; address of char in ascii map
		move.l 	(a1),(a0)	; plot blocks into ascii
		move.l 	4(a1),4(a0)
		move.l 	8(a1),8(a0)
		move.l 	screen2,a3
		move.w 	(a7)+,d1		; told ya!
		mulu 	#160*8,d1		; convert to graphics offset
		add.w 	d1,a3
		addq.w 	#4,a3			; 1
		moveq.l #4,d2			; 7/1
		moveq.l #4,d3
		moveq.l #10,d1
		lea 	wellpic+34+136,a4
		addq.w 	#1,a1
.ploty:	cmp.b 	#'*',(a1)+
		bne.s 	.done
		bsr.s 	.plot1
.done:	add.w 	d2,a3
		move.w 	d2,-(a7)
		move.w 	d3,d2
		move.w 	(a7)+,d3
		subq.w 	#1,d1
		bne.s 	.ploty
		addq.w 	#1,a1
		bra 	.loop
.rts:	bsr 	swap_em
		rts
.plot1:	
		move.l	0*160(a4),0*160(a3)
		move.l	1*160(a4),1*160(a3)
		move.l	2*160(a4),2*160(a3)
		move.l	3*160(a4),3*160(a3)
		move.l	4*160(a4),4*160(a3)
		move.l	5*160(a4),5*160(a3)
		move.l	6*160(a4),6*160(a3)
		move.l	7*160(a4),7*160(a3)
		
		rts

;; arcade level well data-table
;;
;; "none" = normal level (get 10 lines)
;; "_up_" = move blocks up well (get 10 lines)
;; "rand" = random block appearing from time to time (Get 10 lines)
;; "grid" = pre-build grid in the well!
;;
arc_tab:
		.rept 4
		dc.b "none"
		dc.l 0
		dc.b "_up_"
		dc.l 0
		dc.b "grid"
		dc.l boty1
		dc.b "rand"
		dc.l 0
		dc.b "grid"
		dc.l boty2
		dc.b "_up_"
		dc.l 0
		dc.b "grid"
		dc.l lower
		dc.b "none"
		dc.l 0
		dc.b "grid"
		dc.l mid
		dc.b "grid"
		dc.l high
		.endr
		dc.l "none"
		dc.l 0

boty1:	dc.w 22
		dc.b "** * ** * **"
		dc.l -1
boty2:	dc.w 19
		dc.b "*          *"
		dc.w 20
		dc.b "**        **"
		dc.w 21
		dc.b "***      ***"
		dc.w 22
		dc.b "****    ****"
		dc.l -1
lower:	dc.w 17
		dc.b "*          *"
		dc.w 18
		dc.b "**         *"
		dc.w 19
		dc.b "****       *"
		dc.w 20
		dc.b "******     *"
		dc.w 21
		dc.b "********   *"
		dc.w 22
		dc.b "********** *"
		dc.l -1
mid:	dc.w 17
		dc.b "*    **    *"
		dc.w 18
		dc.b "*   ****   *"
		dc.w 19
		dc.b "*  * ****  *"
		dc.w 20
		dc.b "* ****** * *"
		dc.w 21
		dc.b "**  *  *  **"
		dc.w 22
		dc.b "*****  *****"
		dc.l -1
high:	dc.w 12
		dc.b "**        **"
		dc.w 13
		dc.b "**        **"
		dc.w 14
		dc.b "**        **"
		dc.w 15
		dc.b "***      ***"
		dc.w 16
		dc.b "****    ****"
		dc.w 17
		dc.b "*****  *****"
		dc.w 18
		dc.b "**        **"
		dc.w 19
		dc.b "**        **"
		dc.w 20
		dc.b "**        **"
		dc.w 21
		dc.b "**   **   **"
		dc.w 22
		dc.b "** ****** **"
		dc.l -1

up_word:	dc.w 0
up_tabl:	dc.l make_0,make_1,make_2,make_3,make_4
			dc.l make_5,make_6,make_7,make_8,make_9

make_0:	dc.w 22
		dc.b "***      ***"
		dc.l -1
make_1:	dc.w 22
		dc.b "****** *****"
		dc.l -1
make_2:	dc.w 22
		dc.b "** **  ** **"
		dc.l -1
make_3:	dc.w 22
		dc.b "* *  **  * *"
		dc.l -1
make_4:	dc.w 22
		dc.b "******** * *"
		dc.l -1
make_5:	dc.w 22
		dc.b "* ******** *" 
		dc.l -1
make_6:	dc.w 22
		dc.b "*          *"
		dc.l -1
make_7:	dc.w 22
		dc.b "**        **"
		dc.l -1
make_8:	dc.w 22
		dc.b "*    **    *"
		dc.l -1
make_9:	dc.w 22
		dc.b "**** ** ****"
		dc.l -1

;;;;;;;;;;;;;;;;;;;;;
;; Level selection ;;
;;;;;;;;;;;;;;;;;;;;;

reinit:	cmp.l 	#'arca',arcade
		bne.s 	.rts
		bsr 	res_lev
		bsr 	get_arcade_level
		bsr 	process_level
.rts:	rts

init_level:
		cmp.b 	#$10,lastkey		; 'q'
		bne.s 	.cont0
		move.b 	#$10,quitest		; force an exit!
		rts
.cont0:	btst.b 	#7,prockey		; fire! (stick)
		beq.s 	.contz
		
		clr.w	exit_flag
		
		bsr 	reinit
		rts
		
.contz:	cmp.b 	#$39,lastkey		; space!
		bne.s 	.cont0a
		bsr 	reinit
		rts
		
.cont0a:
		cmp.b 	#$2,lastkey		; '1' - beebris mode!
		bne.s 	.cont0b
		clr.l 	arcade
		move.w 	#7,block_num		; reset range
		clr.w 	random_piece
		bsr 	place_well_grafix
		bsr 	erase_ascii
		lea 	score_pic+34+(33*160),a2	; copy to screen
		bsr 	mode_plot
		bsr 	reinit
		bra.s 	init_level
		
.cont0b:
		cmp.b 	#$3,lastkey		; '2' - beebris+ mode!
		bne.s 	.cont0c
		clr.l 	arcade
		move.w 	#14,block_num		; extend range
		clr.w 	random_piece
		bsr 	place_well_grafix
		bsr 	erase_ascii
		lea 	score_pic+34+(33*160)+112,a2	; copy to screen
		bsr 	mode_plot
		bsr 	reinit
		bra 	init_level
.cont0c:
		cmp.b 	#$4,lastkey		; '3' - arcade mdoe!
		bne.s 	.cont0d
		move.l 	#'arca',arcade
		move.w 	#7,block_num		; reset range
		clr.w 	random_piece
		lea 	score_pic+34+(42*160)+112,a2	; copy to screen
		bsr 	mode_plot
		bsr 	reinit
		bra 	init_level
		
.cont0d:
		cmp.b 	#$5,lastkey		; '4' - arcade+ mdoe!
		bne.s 	.cont1
		move.l 	#'arca',arcade
		move.w 	#14,block_num		; extend range
		clr.w 	random_piece
		lea 	score_pic+34+(51*160)+112,a2	; copy to screen
		bsr 	mode_plot
		bsr 	reinit
		bra 	init_level

.cont1:	cmp.b 	#$4e,lastkey		; '+' - increment level
		bne.s 	.cont2
		bsr 	inc_level
		bsr 	check_arc
		bra 	init_level
		
.cont2:	cmp.b 	#$4a,lastkey		; '-' - decrement level
		bne 	init_level
		bsr 	dec_level
		bsr 	check_arc
		bra 	init_level

check_arc:
		cmp.l 	#'arca',arcade		; in arcade mode?
		bne.s 	.rts
		bsr 	get_arcade_level		; do the well up!
		bsr 	process_level
.rts:	rts

inc_level:
		bsr 	big_delay
		cmp.w 	#'40',level		; top level reached?
		beq 	.rts
		addq.w 	#1,level			; add 1 to level number
		bsr 	check_overflow_level	; check the ascii
		bsr 	frame_wait
		lea 	level,a0			; send new number to scren
		move.l 	#104+(160*88),a1
		move.l 	a1,a2
		bsr 	print_number
		bsr 	res_lev			; get new values
.rts:	rts

dec_level:	
		bsr 	big_delay
		cmp.w 	#'00',level		; lowest level?
		beq 	.rts
		subq.w 	#1,level			; sub 1 from level
		bsr 	check_overflow_level	; check the ascii
		bsr 	frame_wait
		lea 	level,a0
		move.l 	#104+(160*88),a1		; send new number to screen
		move.l 	a1,a2
		bsr 	print_number
		bsr 	res_lev			; get new values
.rts:	rts

big_delay:	
		moveq.l #5,d0
.o1:	bsr 	frame_wait
		dbra 	d0,.o1
		rts

mode_plot:
		move.l 	screen1,a0		; rout to copy 
		move.l 	screen2,a1		; 'beebris' or 'beebris+'
		lea 	48+(160*68)(a0),a0		; to top of score panel
		lea 	48+(160*68)(a1),a1
		moveq.l #7,d0
.plotit:
		movem.l (a2),d1-d6
		movem.l d1-d6,(a0)
		movem.l d1-d6,(a1)
		movem.l 24(a2),d1-d4
		movem.l d1-d4,24(a0)
		movem.l d1-d4,24(a1)
		lea 	160(a0),a0
		lea 	160(a1),a1
		lea 	160(a2),a2
		subq.l 	#1,d0
		bne.s 	.plotit
		rts

; stored as speed, y start (ascii), y start (screen)
gfx	equ 160*8
lev_table:
		dc.l 11,0,20,10,0,20,9,0,20,8,0,20
		dc.l 7,0,20,6,0,20,5,0,20,4,0,20
		dc.l 3,0,20,2,0,20				; 0-9

		dc.l 6,1,20+(gfx*1),5,1,20+(gfx*1),4,1,20+(gfx*1),3,1,20+(gfx*1),2,1,20+(gfx*1)  ; 10-14
		dc.l 6,2,20+(gfx*2),5,2,20+(gfx*2),4,2,20+(gfx*2),3,2,20+(gfx*2),2,2,20+(gfx*2)  ; 15-19
		dc.l 6,3,20+(gfx*3),5,3,20+(gfx*3),4,3,20+(gfx*3),3,3,20+(gfx*3),2,3,20+(gfx*3)  ; 20-24
		dc.l 6,4,20+(gfx*4),5,4,20+(gfx*4),4,4,20+(gfx*4),3,4,20+(gfx*4),2,4,20+(gfx*4)  ; 25-29
		dc.l 6,5,20+(gfx*5),5,5,20+(gfx*5),4,5,20+(gfx*5),3,5,20+(gfx*5),2,5,20+(gfx*5)  ; 30-34
		dc.l 6,6,20+(gfx*6),5,6,20+(gfx*6),4,6,20+(gfx*6),3,6,20+(gfx*6),2,6,20+(gfx*6)  ; 35-39

		dc.l 2,7,20+(gfx*7)		; level 40 - no chance!

***********************************************************************
*    The Game Over Routine. Maybe You'll Do Better Next Time, Eh???   *
***********************************************************************

game_over:
		lea 	score_pic+34+(165*160),a0	; "Game Over - Push Space"
		bsr 	line_out			; send to screen

		bsr 	frame_wait		; wait for vbl

;; play game over sample
;;
				movem.l	d0-a6,-(a7)
				move.l	#aww,a0
				lea		$0,a1
				move.l	#14129,d0					; sample length
				moveq	#0,d1						; looplength (unlooped)
				moveq	#10,d2						; priority (high)
				move.l	#240,d3						; volume
				moveq	#0,d4						; freq
				jsr		musicplayer+$c
				
				move.l	#50,d7
.waiter:		bsr		frame_wait
				dbra	d7,.waiter
				
				movem.l	(a7)+,d0-a6
				
		move.l 	#80,d0
.shitty:
		bsr 	frame_wait
		dbra 	d0,.shitty
		
		bsr		do_webcode_display

		bsr 	erase_ascii
		clr.w	lastkey
		clr.w	prockey
		clr.w	exit_flag
		
		move.l	screen1,a0			; erase next block
		move.l	screen2,a1
		add.l	#72+(160*88),a0
		add.l	#72+(160*88),a1
		move.l	#31,d7
.erase:	clr.l	(a0)+
		clr.l	(a0)+
		clr.l	(a0)+
		clr.l	(a0)+
		clr.l	(a1)+
		clr.l	(a1)+
		clr.l	(a1)+
		clr.l	(a1)+
		lea		144(a0),a0
		lea		144(a1),a1
		dbra	d7,.erase
				
		bra 	reset		; go start a new game!

erase_ascii:
		lea 	well,a0		; now I must clear out the ascii map
		move.l 	#23,d0		; of the well
wipe_well:
		clr.b 	1(a0)
		clr.l 	2(a0)
		clr.l 	6(a0)
		clr.b 	10(a0)
		lea 	12(a0),a0
		subq.l 	#1,d0
		bne.s 	wipe_well
		rts

************************************************************************
*                  Increment all relevant pointers                     *
************************************************************************

increment_verticals:
		addq.w 	#1,well_y		; ascii position down 1 line
		add.l 	#160*8,address_offset	; grafix position down 8 scanlines
		rts

************************************************************************
*   This places the piece into the ascii map of the well............   *
************************************************************************

bomb_line:
		cmp.l 	#bld,current_piece	; was that a bomb?
		bne.s 	_exit_
		lea 	well,a0		; well ascii map
		move.w 	well_y,d1	; line finished on
		mulu 	#12,d1		; by 12
		add.w 	d1,a0
		move.l 	#'****',(a0)	; make line full!
		move.l 	#'****',4(a0)
		move.l 	#'****',8(a0)
_exit_:	rts

plot_well:
		lea 	well,a0		; address of ascii map
		add.w 	well_x,a0		; add horizontal offsets
		move.w 	well_y,d1	; get the vertical offset
		mulu 	#12,d1		; and mult by 12 to get offset
		add.w 	d1,a0		; address of char in ascii map

		lea 	character,a1	; ascii table for current shape

		.rept 4			; all shapes four lines high!
		cmp.b 	#'*',(a1)+	; is it a square?
		dc.w 	$6604		; branch if not (No labels in Rept loops)
		bsr 	place_star		; yes so plot in the ascii map
		addq.l 	#1,a0		; jump to next pos
		cmp.b 	#'*',(a1)+
		dc.w 	$6604
		bsr 	place_star
		addq.l 	#1,a0
		cmp.b 	#'*',(a1)+
		dc.w 	$6604
		bsr 	place_star
		addq.l 	#1,a0
		cmp.b 	#'*',(a1)+
		dc.w 	$6604
		bsr 	place_star
		add.l 	#9,a0		; jump to next line!
		.endr			; and repeat it all again!

		move.l 	#40000,wibble	; 'somewhere' between screens!

		rts

place_star:
		move.b 	#'*',(a0)	; plot a star (square) in ascii map
		rts

**********************************************************************
* Check to see if lines are made, and if so, adjust the screen & map *
**********************************************************************

clunknoise:	dc.w	0

check_for_line:
		clr.w	clunknoise
		move.w 	#0,current_drops
checker:
		move.w 	#1,goes		; flag use to check if any lines moved
		lea 	well_bot,a0		; bottom of the well
		move.l 	#23,d7		; check upwards for 23 lines		
		move.l 	#22*8*160,on_screen	; screen offset to current line
check_loopy:
		bsr 	check_well_line	; check for a line
		lea 	-12(a0),a0		; decrement backwards 1 line in ascii
		sub.l 	#8*160,on_screen	; decrement backwards 8 on screen
		subq.l 	#1,d7		; loop around
		bne.s 	check_loopy
		tst.w 	goes		; any moved?
		bmi 	checker		; branch if yes

		tst.w	clunknoise
		bne		.rtser
				movem.l	d0-a6,-(a7)
				move.l	#droptin,a0
				lea		$0,a1
				move.l	#8238,d0					; sample length
				moveq	#0,d1						; looplength (unlooped)
				moveq	#10,d2						; priority (high)
				move.l	#180,d3						; volume
				moveq	#0,d4						; freq
				jsr		musicplayer+$c
				movem.l	(a7)+,d0-a6
.rtser:
		rts					; fall out here when finished

check_well_line:
		cmp.l 	#'****',(a0)	; start testing
		bne 	__rts		; branch if not complete
		cmp.l 	#'****',4(a0)
		bne 	__rts
		cmp.l 	#'****',8(a0)
		bne 	__rts

		move.w	#1,clunknoise
		addq.w 	#1,current_drops	; fall here if line made
		addq.w 	#1,lines_done	; add 1 line made (level counter)
		move.w 	#-1,line_dn	; reset flag
		move.w 	#-1,goes		; reset flag (what? I can't remember this!)
		bsr 	drop_ascii		; must correct ascii map
		bsr 	move_em
		bsr 	frame_wait
		bsr 	drop_grafix		; and also the screen image!
		bsr 	swap_em

._do_b:	bsr 	_boom_

__rts:	rts						; else get to here

bugflag:	dc.w -1

process_bounce:
		tst.w 	bugflag
		bmi 	.rts
.ST:	cmp.w 	#'ST',bugflag
		bne.s 	.SB
		move.l 	screen1,xx1
		move.l 	screen2,xx2
		move.w 	#-1,bugflag
		rts
		
.SB:	cmp.w 	#'SB',bugflag
		bne.s 	.RE
		sub.l 	#160*8,screen1
		sub.l 	#160*8,screen2
		move.w	#1,bouncing_flag
		move.w 	#-1,bugflag
		rts
		
.RE:	cmp.w 	#'RE',bugflag
		bne.s 	.SW
		move.l 	xx1,screen1
		move.l 	xx2,screen2
		move.w	#0,bouncing_flag
		move.w 	#-1,bugflag
		rts
		
.SW:	move.l 	screen1,tt1
		move.l 	screen2,screen1
		move.l 	tt1,screen2
		move.w 	#-2,bugflag
.rts:	rts

xx1:	dc.l 0
xx2:	dc.l 0
tt1:	dc.l 0
	
_boom_:
.hang1:	move.w 	#'ST',bugflag	; STore
		bsr 	frame_wait
		bsr 	frame_wait
		move.w 	#'SB',bugflag	; SuBtract  160*8

;; play boom sample
;;
				movem.l	d0-a6,-(a7)
				move.l	#gling,a0
				lea		$0,a1
				move.l	#10054,d0					; sample length
				moveq	#0,d1						; looplength (unlooped)
				moveq	#10,d2						; priority (high)
				move.l	#240,d3						; volume
				moveq	#0,d4						; freq
				jsr		musicplayer+$c
				
				movem.l	(a7)+,d0-a6


		
		move.w 	#10,d0
.booom:	bsr 	frame_wait		; wait for sample to finish
		dbra 	d0,.booom
		move.w 	#'RE',bugflag
		bsr 	frame_wait
		bsr 	frame_wait
		move.w 	#-1,bugflag
		bsr 	frame_wait
		rts

do_mus:	dc.w 1

drop_ascii:
		move.l 	d7,d0		; number of lines above this one
		move.l 	a0,a1		; can't trash a0!!!!
buggery:
		move.l 	-12(a1),(a1)	; copy line above in ascii
		move.l 	-8(a1),4(a1)	; down the screen
		move.l 	-4(a1),8(a1)
		lea 	-12(a1),a1
		subq.l 	#1,d0
		bpl.s 	buggery
		rts	

drop_grafix:
		move.l 	screen2,a6
		add.l 	on_screen,a6
		move.l 	a6,a4		
		lea 	-8*160(a4),a4	; must get data from 8 line above

		move.w 	d7,d6		; number of lines in d6
		subq.w 	#1,d6		; but only copy 1 less
what_a_bummer:
		bsr 	frame_wait		; v-sync (causes a ripple when line made)

		movem.l 0*160(a4),d0-d5	; grab data from line above
		movem.l d0-d5,0*160(a6)	; then screen #2
		movem.l 24(a4),d0-d5	; next chunk
		movem.l d0-d5,24(a6)	; place in #2
		movem.l 1*160(a4),d0-d5	; grab data from line above
		movem.l d0-d5,1*160(a6)	; then screen #2
		movem.l 184(a4),d0-d5	; next chunk
		movem.l d0-d5,184(a6)	; place in #2
		movem.l 2*160(a4),d0-d5	; grab data from line above
		movem.l d0-d5,2*160(a6)	; then screen #2
		movem.l 344(a4),d0-d5	; next chunk
		movem.l d0-d5,344(a6)	; place in #2
		movem.l 3*160(a4),d0-d5	; grab data from line above
		movem.l d0-d5,3*160(a6)	; then screen #2
		movem.l 504(a4),d0-d5	; next chunk
		movem.l d0-d5,504(a6)	; place in #2
		movem.l 4*160(a4),d0-d5	; grab data from line above
		movem.l d0-d5,4*160(a6)	; then screen #2
		movem.l 664(a4),d0-d5	; next chunk
		movem.l d0-d5,664(a6)	; place in #2
		movem.l 5*160(a4),d0-d5	; grab data from line above
		movem.l d0-d5,5*160(a6)	; then screen #2
		movem.l 824(a4),d0-d5	; next chunk
		movem.l d0-d5,824(a6)	; place in #2
		movem.l 6*160(a4),d0-d5	; grab data from line above
		movem.l d0-d5,6*160(a6)	; then screen #2
		movem.l 984(a4),d0-d5	; next chunk
		movem.l d0-d5,984(a6)	; place in #2
		movem.l 7*160(a4),d0-d5	; grab data from line above
		movem.l d0-d5,7*160(a6)	; then screen #2
		movem.l 1144(a4),d0-d5	; next chunk
		movem.l d0-d5,1144(a6)	; place in #2

		lea 	-160*8(a4),a4	; jump all backwards by 8 lines
		lea 	-160*8(a6),a6
		subq.w 	#1,d6		; loop until finished
		bpl 	what_a_bummer

		rts

swap_em:
		move.w 	#'SW',bugflag
.hangit:
		cmp.w 	#-2,bugflag
		bne.s 	.hangit
		move.w 	#-1,bugflag
		rts

move_em:
		movem.l d0-a6,-(a7)		; copy the well from the
		move.l 	screen1,a5		; display screen to the
		move.l 	screen2,a6		; working screen
		
		move.l	#193,d7
.xloop:
		movem.l	(a5),d0-d6/a0-a4
		movem.l	d0-d6/a0-a4,(a6)
		lea		160(a5),a5
		lea		160(a6),a6
		dbra	d7,.xloop

		movem.l (a7)+,d0-a6
		rts

************************************************************************
*  This tests a position map to see if hit square. Values are in Dbase *
*        Each square can only have up to four positions to test        *
************************************************************************
	
test_positions:
		lea 	well,a0		; address of well ascii
		move.w 	well_y,d0	; get vertical
		mulu 	#12,d0		; offset into d0
		add.l 	d0,a0		; plus vertical offset
		add.w 	well_x,a0		; plus horizontal offset
		move.l 	a0,-(a7)		; save on stack
	
check1:
		add.w 	(a1)+,a0		; 1st x-check
		move.w 	(a1)+,d1		; 1sr y-check
		mulu 	#12,d1
		add.l 	d1,a0
		cmp.b 	#'*',(a0)	
		beq 	stop_me	
check2:	move.l 	(a7),a0		; from stack
		add.w 	(a1)+,a0		; 2nd x-check
		move.w 	(a1)+,d1		; 2nd y-check
		mulu 	#12,d1
		add.l 	d1,a0
		cmp.b 	#'*',(a0)
		beq 	stop_me
check3:	move.l 	(a7),a0		; from stack
		add.w 	(a1)+,a0		; 3rd x-check
		move.w 	(a1)+,d1		; 3rd y-check
		mulu 	#12,d1
		add.l 	d1,a0
		cmp.b 	#'*',(a0)
		beq 	stop_me
check4:	move.l 	(a7),a0		; from stack
		add.w 	(a1)+,a0		; 4th x-check
		move.w 	(a1)+,d1		; 4th y-check
		mulu 	#12,d1
		add.l 	d1,a0
		cmp.b 	#'*',(a0)
		beq 	stop_me
check5:	move.l 	(a7),a0		; from stack
		add.w 	(a1)+,a0		; 5th x-check
		move.w 	(a1)+,d1		; 5th y-check
		mulu 	#12,d1
		add.l 	d1,a0
		cmp.b 	#'*',(a0)
		beq 	stop_me

		addq.l 	#4,a7		; correct stack
		moveq 	#1,d0		; here if all clear, set d0 to 0
		rts

stop_me:
		addq.l 	#4,a7		; correct stack
		moveq 	#-1,d0		; here if hit, set d0 to -1
		rts

************************************************************************
*                       Keyboard controls are here                     *
************************************************************************

scan_keyboard:

.cont:	cmp.b 	#$10,lastkey	; 'q'
		beq 	setquit
	
		cmp.b 	#$19,lastkey	; 'p'
		beq 	pause

		move.b 	prockey,d7	; pull value from ikbd

		move.w 	#1,donelst

		cmp.b 	#2,d7		; joys DOWN
		beq 	turbo

		bclr 	#2,d7		; joys left/diagonal
		beq 	.lft
		bsr 	left
.lft:	bclr 	#3,d7		; joys right/diagonal
		beq 	.rigt
		bsr 	right
.rigt:	bclr 	#7,d7		; joys fire!
		beq.s 	.rot
		bsr 	rotate
.rot:	move.b 	lastkey,d7
		cmp.b 	#$4b,d7		; curs left
		beq 	left
		cmp.b 	#$4d,d7		; curs right
		beq 	right
		cmp.b 	#$48,d7		; curs up! - rotate
		beq 	rotate
		cmp.b 	#$50,d7		; cursor down - fast drop piece
		beq 	turbo

		move.l 	levspd,xspeed
		clr.w 	drphgt

		rts

turbo:	move.l 	#1,xspeed		; fast speed on!
		rts

setquit:
		move.b 	#$10,quitest	; 'q' flagged
		rts

quitest:	dc.w 0
drphgt:		dc.w 0	

left:
		clr.w 	drphgt
		move.l 	levspd,xspeed	; reset current speed (abort fast)

		lea 	lft1,a1		; pointer to left check co-ords
		bsr 	test_positions	; go test em
		bmi.s 	_rts		; branch if illegal

		move.w 	#1,drops
		move.l 	next_sub,d0	; adjust MOVEP offsets
		sub.l 	d0,address_offset	; and screen pointer
		bsr 	swap_nums		; swap MOVEP offsets
		subq.w 	#1,well_x	; left 1 in ascii
_rts:	rts

right:	clr.w 	drphgt
		move.l 	levspd,xspeed	; reset speed

		lea 	rgh1,a1		; pointer to right check co-ords
		bsr 	test_positions	; go test em
		bmi.s 	_rts		; branch if illegal

		move.w 	#1,drops
		move.l 	next_add,d0	; adjust MOVEP offsets
		add.l 	d0,address_offset	; and screen pointer
		bsr 	swap_nums		; SWAP MOVEP offsets
		addq.w 	#1,well_x	; right 1 in ascii
		rts

rotate:	clr.w 	drphgt
		move.l 	levspd,xspeed	; reset speed

		lea 	rot1,a1		; pointer to next rotation co-ords
		bsr 	test_positions	; go test em
		bmi.s 	_rts		; branch if illegal
	
		bsr 	frame_wait

		bsr 	frame_wait
		move.w 	#1,drops
		addq.w 	#4,current_rot	; pointer to next chatacter
		cmp.w 	#16,current_rot	; at rotation #4
		bne.s 	._rts		; branch if no
		clr.w 	current_rot	; reset to rotation 0

._rts:	bsr 	jmp_grab_piece	; get piece from database
		rts

swap_nums:
		move.l 	next_add,d0	; exchange the MOVEP offset values
		move.l 	next_sub,next_add
		move.l 	d0,next_sub
		rts

pause:	lea 	score_pic+34+(156*160),a0	; "Game Paused - Push P"
		bsr 	line_out		; send to screen

		move.l 	#5,d0		; wait 5 frames
.skrew:	bsr 	frame_wait
		subq.l 	#1,d0
		bne.s 	.skrew

p_push:	tst.w	PAUSE_ON
		bne.s	p_push
		
;p_push:	cmp.b 	#$19,lastkey 	; wait for 'P'
;		bne.s 	p_push

		lea 	score_pic+34+(174*160),a0 ; blank line
		bsr 	line_out		; send to screen

		move.l 	#5,d0		; wait 5 frames
.skrew:	bsr 	frame_wait
		subq.l 	#1,d0
		bne.s 	.skrew

		rts

***************************************************************************
*                      Routine to Un-plot a block                         *
***************************************************************************

unplot_block:
		bsr 	frame_wait

		move.l 	screen2,a5
		lea 	savbuff,a4		; with data from the buffer
		move.l 	wibble,d0
		add.l 	d0,a5

		move.l	#31,d7
.xxxl:	movem.l	(a4)+,d0-d6/a0-a3/a6
		movem.l	d0-d6/a0-a3/a6,(a5)
		lea		160(a5),a5
		dbra	d7,.xxxl
		
		rts

************************************************************************
*             Grab a completely fresh piece from the Dbase             *
************************************************************************

grab_piece:
		moveq 	#0,d0		; clear d0
		move.w 	random_piece,d0	; vbl counter
		add 	d0,d0		; times it
		add 	d0,d0		; by 4
		lea 	piece_table,a0	; and load table start
		move.l 	next_shape,current_piece
		move.l 	(a0,d0),next_shape	; pull pointer


;             **************************************
;             * Jump here when new rotation needed *
;             **************************************

jmp_grab_piece:
		move.l 	current_piece,a0	; pointer to current piece
		move.l 	12(a0),first_rotate ; data of first rotation
		add.l 	#80,first_rotate	; offset to position values
									; this was THE BASTARD OF A BUG!!!
		move.w 	current_rot,d0	; rotation value
		move.l 	(a0,d0),a0	; get pointer to shape table 
		move.w 	(a0)+,width	; pull width  (not used!)
		move.w 	(a0)+,height	; pull height (not used!)

		lea character,a1	; and copy 21 longwords
		.rept 25			; of data in the current shape
		move.l (a0)+,(a1)+	; buffer
		.endr
		rts

************************************************************************
*    Plot a block to next shape. Warning. Uses MOVEP/odd addressing!   *
************************************************************************

display_next:
		move.l 	address_offset,-(a7)	; save attributes
		move.l 	current_piece,-(a7)
		move.l 	next_add,-(a7)
		move.l 	next_sub,-(a7)
		move.l 	#72+(160*88),address_offset
		move.l 	#4,next_add
		move.l 	#4,next_sub
		move.l 	next_shape,current_piece	; swap for next
		bsr 	jmp_grab_piece		; get details
		bsr 	frame_wait			
		bsr 	move_em	
		bsr 	frame_wait
		bsr 	clear_old			; wipe old next
		bsr 	jmp_into_plot		; plot next (screen #1)
		bsr 	swap_em
		bsr 	frame_wait
		bsr 	move_em
		bsr 	frame_wait
		bsr 	clear_old
		bsr 	jmp_into_plot		; plot next (screen #2)
		bsr 	swap_em
		move.l 	(a7)+,next_sub		; restore attributes
		move.l 	(a7)+,next_add
		move.l 	(a7)+,current_piece
		move.l 	(a7)+,address_offset
		bsr 	jmp_grab_piece		; re-fetch current shape
		rts

clear_old:
		movem.l score_pic+34+(160*32),d1-d2
		move.l 	screen2,a1
		lea 	72+(160*88)(a1),a1
		move.l 	#31,d0
.kill_Andy:
		movem.l d1-d2,(a1)
		movem.l d1-d2,8(a1)
		lea 	160(a1),a1
		dbra 	d0,.kill_Andy
		rts

************************************************************************
*    Plot a block to the screen. Warning. Uses MOVEP/odd addressing!   *
************************************************************************

plot_block:
		move.l 	screen2,a0	; address of screen
		lea 	savbuff,a1		; save buffer
		move.w 	well_y,d0
		mulu 	#160*8,d0		; and add offset
		add.l 	d0,a0	
		move.l 	d0,wibble	; save for use by un-plotter

		move.l	#31,d7
.xxxk:	movem.l	(a0),d0-d5
		movem.l	d0-d5,(a1)
		movem.l 24(a0),d0-d5
		movem.l	d0-d5,24(a1)
		lea		48(a1),a1
		lea		160(a0),a0
		dbra	d7,.xxxk
		
jmp_into_plot:
		lea 	character,a0	; current character attributes
;		move.l 	next_add,d0	; adjust MOVEP
;		move.l 	next_sub,d1	; adjust MOVEP
		moveq	#4,d0
		moveq	#4,d1

		move.w	#4,second
		move.w	#8,third
		move.w	#12,fourth
;		move.w 	d0,second	; make positions
;		move.w 	d0,third		; "
;		add.w 	d1,third		; "
;		move.w 	third,fourth	; "
;		add.w 	d0,fourth		; "

		moveq 	#0,d0		; and clear d0

_0_0:	cmp.b 	#'*',(a0)		; test for '*'
		bne.s 	_0_1
		move.l 	#0,d0		; offset
		bsr 	plot_cube		; draw a block
_0_1:	cmp.b 	#'*',1(a0)
		bne.s 	_0_2
		move.l	#4,d0
		bsr 	plot_cube
_0_2:	cmp.b 	#'*',2(a0)
		bne.s 	_0_3
		move.l	#8,d0
		bsr 	plot_cube
_0_3:	cmp.b 	#'*',3(a0)
		bne.s 	_1_0
		move.l	#12,d0
		bsr 	plot_cube
_1_0:	cmp.b 	#'*',4(a0)
		bne.s 	_1_1
		move.l 	#160*8,d0	; next line	
		bsr 	plot_cube
_1_1:	cmp.b 	#'*',5(a0)
		bne.s 	_1_2
		move.l 	#(160*8)+4,d0
		bsr 	plot_cube
_1_2:	cmp.b 	#'*',6(a0)
		bne.s 	_1_3
		move.l 	#(160*8)+8,d0
		bsr 	plot_cube
_1_3:	cmp.b 	#'*',7(a0)
		bne.s 	_2_0
		move.l 	#(160*8)+12,d0
		bsr plot_cube
_2_0:	cmp.b 	#'*',8(a0)
		bne.s 	_2_1
		move.l 	#160*16,d0	; next line
		bsr 	plot_cube
_2_1:	cmp.b 	#'*',9(a0)
		bne.s 	_2_2
		move.l 	#(160*16)+4,d0
		bsr 	plot_cube
_2_2:	cmp.b 	#'*',10(a0)
		bne.s 	_2_3
		move.l 	#(160*16)+8,d0
		bsr		plot_cube
_2_3:	cmp.b 	#'*',11(a0)
		bne.s 	_3_0
		move.l 	#(160*16)+12,d0
		bsr 	plot_cube
_3_0:	cmp.b 	#'*',12(a0)
		bne.s 	_3_1
		move.l 	#160*24,d0	; next line
		bsr 	plot_cube
_3_1:	cmp.b 	#'*',13(a0)
		bne.s 	_3_2
		move.l 	#(160*24)+4,d0
		bsr 	plot_cube
_3_2:	cmp.b 	#'*',14(a0)
		bne.s 	_3_3
		move.l 	#(160*24)+8,d0
		bsr 	plot_cube
_3_3:	cmp.b 	#'*',15(a0)
		bne.s 	_exit
		move.l 	#(160*24)+12,d0
 		bsr 	plot_cube
_exit:	rts

plot_cube:
		move.l 	screen2,a2	; screen #2
		add.l 	address_offset,a2
		add.l 	d0,a2
		move.l 	current_colour,a3	; colour

		move.l 	0*160(a3),d0
		move.l 	d0,0*160(a2)
		move.l 	1*160(a3),d0
		move.l 	d0,1*160(a2)
		move.l 	2*160(a3),d0
		move.l 	d0,2*160(a2)
		move.l 	3*160(a3),d0
		move.l 	d0,3*160(a2)
		move.l 	4*160(a3),d0
		move.l 	d0,4*160(a2)
		move.l 	5*160(a3),d0
		move.l 	d0,5*160(a2)
		move.l 	6*160(a3),d0
		move.l 	d0,6*160(a2)
		move.l 	7*160(a3),d0
		move.l 	d0,7*160(a2)
		
		rts

*********************************************************************
*              Routine to draw the well onto the screen             *
*********************************************************************

place_well_grafix:
		move.l 	screen1,a0	; screen #1
		move.l 	screen2,a1	; screen #2
		lea 	-8*160(a0),a0
		lea 	-8*160(a1),a1
		moveq.l #10,d0		; lines to copy!
		bsr 	dowell
		move.l 	screen1,a0	; screen #1
		move.l 	screen2,a1	; screen #2
		move.l 	#200,d0		; lines to copy!
		bsr 	dowell
		rts

dowell:
		lea 	wellpic+34,a2	; picture of well
do_well:
		move.l 	#12,d1		; 12 longs=96 pixels/4 planes
cruxy:	move.l 	(a2),(a0)+	; send to screen
		move.l 	(a2)+,(a1)+	; and other screen
		subq.l 	#1,d1
		bne.s 	cruxy
		lea 	112(a0),a0		; next line
		lea 	112(a1),a1
		lea 	112(a2),a2
		subq.l 	#1,d0		; loop around
		bne.s 	do_well
		rts

************************************************************************
*                 Routine to Draw the score panel frame                *
************************************************************************
	
place_panel:
		move.l 	screen1,a0	; screen #1
		move.l 	screen2,a1	; screen #2
		lea 	48+(160*68)(a0),a0	; normal screen+a bit
		lea 	48+(160*68)(a1),a1
		lea 	score_pic+34+(33*160),a2	; panel grafix
		move.l	 #113,d0		; panel is 113 lines high (wow!)
do_panl:
		move.l 	#28,d1		; copy 28 longs=224 pixels/4 planes
panl:	move.l 	(a2),(a0)+	; to screen #1
		move.l 	(a2)+,(a1)+	; and screen #2
		subq.l 	#1,d1
		bne.s 	panl
		lea 	48(a0),a0		; next line
		lea 	48(a1),a1
		lea 	48(a2),a2
		subq.l 	#1,d0		; loop around
		bne.s 	do_panl
		rts

**********************************************************************
*    Routine to plot the credits in the top right of the screen      *
**********************************************************************

credits:
		lea 	wellpic+34+48+(8*160),a5
		move.l 	screen1,a6	; screen not being displayed!
		lea 	48(a6),a6 	; add a bit
		bsr 	dump_creds
		move.l 	screen2,a6	; screen not being displayed!
		lea 	48(a6),a6 	; add a bit
		bsr 	dump_creds
		rts

dump_creds:
		move.l	a5,-(a7)
		move.l	#60,d7
.xxxl:	move.l	(a5),(a6)
		move.l	4(a5),4(a6)
		move.l	8(a5),8(a6)
		move.l	12(a5),12(a6)
		move.l	16(a5),16(a6)
		move.l	20(a5),20(a6)
		move.l	24(a5),24(a6)
		move.l	28(a5),28(a6)
		move.l	32(a5),32(a6)
		move.l	36(a5),36(a6)
		move.l	40(a5),40(a6)
		move.l	44(a5),44(a6)
		move.l	48(a5),48(a6)
		move.l	52(a5),52(a6)
		move.l	56(a5),56(a6)
		move.l	60(a5),60(a6)
		move.l	64(a5),64(a6)
		move.l	68(a5),68(a6)
		move.l	72(a5),72(a6)
		move.l	76(a5),76(a6)
		move.l	80(a5),80(a6)
		move.l	84(a5),84(a6)
		move.l	88(a5),88(a6)
		move.l	92(a5),92(a6)
		move.l	96(a5),96(a6)
		move.l	100(a5),100(a6)
		move.l	104(a5),104(a6)
		move.l	108(a5),108(a6)
		lea		160(a5),a5
		lea		160(a6),a6
		dbra	d7,.xxxl
		move.l	(a7)+,a5
		rts

**********************************************************************
*         Routine to send "text" to the bottom of the screen         *
**********************************************************************

; call with a0 address of grafix

line_out:	
		move.l 	screen1,a1	; screen #1
		move.l 	screen2,a2	; screen #2
		add.l 	#(182*160)+48,a1	; plus normal offset
		add.l 	#(182*160)+48,a2	;
		move.l 	#9,d0		; nine lines high
line_sc:
		move.l	#27,d2
.inner:	move.l	(a0)+,d1
		move.l	d1,(a1)+
		move.l	d1,(a2)+
		dbra	d2,.inner
		
		lea		48(a0),a0
		lea		48(a1),a1
		lea		48(a2),a2
		subq.l 	#1,d0		; loop around
		bne 	line_sc
		rts

;; crap but working ikbd interupt


acia_wrapper:
		clr.b	lastkey
		clr.b	prockey
		tst.w	dpad_b
		beq.s	.chk_2
		bset	#7,prockey
.chk_2:	tst.w	dpad_down
		beq.s	.chk_3
		move.b	#2,prockey
		bra		.chk_6
.chk_3:	tst.w	dpad_left
		beq.s	.chk_4
		bset	#2,prockey
.chk_4:	tst.w	dpad_right
		beq.s	.chk_5
		bset	#3,prockey
.chk_5:	tst.w	dpad_c
		beq		.chk_6
		bset	#7,prockey
.chk_6:	tst.w	exit_flag
		beq		.chk_7
		move.b	#1,lastkey
.chk_7:	tst.w	dpad_1
		beq		.chk_8
		move.b	#2,lastkey
.chk_8:	tst.w	dpad_2
		beq		.chk_9
		move.b	#3,lastkey
.chk_9:	tst.w	dpad_3
		beq		.chk_a
		move.b	#4,lastkey
.chk_a:	tst.w	dpad_4
		beq		.chk_b
		move.b	#5,lastkey
.chk_b:	tst.w	dpad_6
		beq		.chk_c
		move.b	#$4e,lastkey
.chk_c:	tst.w	dpad_9
		beq		.chk_d
		move.b	#$4a,lastkey
.chk_d:
		tst.w	PAUSE_ON
		beq		.chk_e
		move.b	#$19,lastkey
.chk_e:	


		rts
		

ikbd118:
		move.w 	d0,-(a7)		; uses D0
		move.b 	$fffffc02.w,d0	; pull data byte
		cmp.w 	#1,joytest	; is it a packet?
		beq.s 	.joy		; branch if yes!
		cmp.b 	#$ff,d0		; is it a packer header?
		bne.s 	.key		; branch if not
		move.w 	#1,joytest	; next incoming is packet data
		move.w 	(a7)+,d0
		bclr.b 	#6,$fffffa11.w
		rte
		
.key:	move.b 	d0,lastkey	; this was a key!
		move.w 	(a7)+,d0
		bclr.b 	#6,$fffffa11.w
		rte
		
.joy:	clr.w 	joytest		; clear packet flag
		btst 	#7,d0		; now test all the bits
		bne.s 	.not1
		move.b 	d0,prockey	; and save if needed
		move.w 	#-1,donelst	; set flag
.not1:	btst 	#1,d0
		bne.s 	.not2
		move.b 	d0,prockey
		move.w 	#-1,donelst
.not2:	btst 	#2,d0
		bne.s 	.not4
		move.b 	d0,prockey
		move.w 	#-1,donelst
.not4:	btst 	#3,d0
		bne.s 	.not8
		move.w 	#-1,donelst
		move.b 	d0,prockey
.not8:	cmp.b 	#$0,d0		; returned to centre?
		bne.s 	.exit
		tst.w 	donelst		; has last been processed
		bmi.s 	.exit
		move.b 	d0,prockey
.exit:	move.w 	(a7)+,d0
		bclr.b 	#6,$fffffa11.w
		rte

button:		dc.w 0
joytest:	dc.w 0
lastjoy:	dc.w 0
prockey:	dc.w 0
donelst:	dc.w 1
lastkey:	dc.w 0

**********************************************************************
*               Routine to wait for space to be pressed              *
**********************************************************************

wait_space:
		btst.b 	#7,prockey
		bne.s 	_rts_
		cmp.b 	#$39,lastkey	; $39 = space
		bne.s 	chk_qt
_rts_:	rts
chk_qt:	bra 	wait_space


**********************************************************************
*       Routine to make the table of number grafix pointers          *
**********************************************************************

make_num_table:
		lea 	numtab,a0		; address of table
		lea 	score_pic+34,a1	; address of '0'
		move.l 	#10,d1			; 10 numbers (wow! never!)
add_tab:
		move.l 	a1,(a0)+		; copy address
		lea 	16(a1),a1		; jump to next grafix
		subq.l 	#1,d1			; and loop
		bne.s 	add_tab
		rts

**********************************************************************
*    Routine to print a -ve terminated numeric string to screen      *
**********************************************************************

print_number:
		lea 	numtab,a3		; points to table
		add.l 	screen1,a1	; points to screen #1
		add.l 	screen2,a2	; points to screen #2
		moveq.l #0,d1
pr_loop:
		move.b 	(a0)+,d1		; pull character			
		bmi 	bogoff		; get out if ended
		sub.b 	#'0',d1		; convert to numeric
		add 	d1,d1
		add 	d1,d1
		move.l 	(a3,d1),a4	; pointer to character grfx
		bsr 	plot_a_number	; plot the grafix
		lea 	16(a1),a1		; and jump to next space
		lea 	16(a2),a2
		bra 	pr_loop		; loop around
bogoff:	rts		

plot_a_number:
		movem.l	a1/a2/a4,-(a7)
		move.l	#31,d6
.innr:	movem.l	(a4),d2-d5
		movem.l	d2-d5,(a1)
		movem.l	d2-d5,(a2)
		lea		160(a4),a4
		lea		160(a1),a1
		lea		160(a2),a2
		dbra	d6,.innr
		movem.l	(a7)+,a1/a2/a4
		rts

*********************************************************************
*  Routines to check if the score / level numbers have overflowed   *
*********************************************************************

check_overflow_score:
		cmp.l 	#'999:',score	; check for 9999 wrap
		bne.s 	.o1
		move.l	#'0000',score
		addq.b 	#1,score-1
		cmp.b 	#':',score-1
		bne.s 	.o1
		move.b 	#'0',score-1
		addq.b 	#1,score-2
		cmp.b 	#':',score-2
		bne.s 	.o2
		move.b 	#'0',score-2

.o1:	cmp.b 	#':',score+3	; check for units wrap
		bne.s 	.o2
		move.b 	#'0',score+3
		addq.b 	#1,score+2
		cmp.b 	#':',score+2	; check for 10's wrap
		bne.s 	.o2
		move.b 	#'0',score+2
		addq.b 	#1,score+1	
		cmp.b 	#':',score+1	; check for 100's wrap
		bne.s 	.o2
		move.b 	#'0',score+1
		addq.b 	#1,score
.o2:	rts

check_overflow_level:
		cmp.b 	#':',level+1	; overflow
		bne.s 	.o2
		move.b 	#'0',level+1
		addq.b 	#1,level
.o2:	cmp.b 	#'/',level+1	; underflow(?)
		bne.s 	.o3
		move.b 	#'9',level+1
		subq.b 	#1,level
.o3:	rts


**********************************************************************
*                   The Vertical Blanking Routine                    *
**********************************************************************

bouncing_flag:	dc.w	0
	
vbl:
		movem.l d0-a6,-(a7)
	
		bsr 	process_bounce

		move.l	screen_obj,a0
		move.l	#20,d0
		move.l	#27,d1
		move.l	screen1,d2
		bsr		setup_object_xyg	; set new screen
		
		move.l	lowborder_obj,a0
		move.l	#17,d0
		move.l	#20+200,d1
		move.l	screen1,d2
		add.l	#(160*205),d2
		bsr		setup_object_xyg

		move.l	newtris_obj,a0
		move.l	#20+(320-216),d0
		move.l	#27,d1
		tst.w	bouncing_flag
		beq.s	.nobnc
		add.l	#8,d1
.nobnc:	bsr		setup_object_xy

		move.l	well_obj,a0
		move.l	#20,d0
		move.l	#26,d1
		tst.w	bouncing_flag
		beq.s	.nobnd
		add.l	#8,d1
.nobnd:	bsr		setup_object_xy

		move.l	scoremask_obj,a0
		move.l	#127,d0
		move.l	#96,d1
		tst.w	bouncing_flag
		beq.s	.nobne
		add.l	#8,d1
.nobne:	bsr		setup_object_xy
		
		bsr		tracking_vbl
		
		jsr		copy_olist

		addq.w 	#1,random_piece		; Random Piece update
		move.w 	block_num,d0
		cmp.w 	random_piece,d0
		bne.s 	.out
		move.w 	#0,random_piece
.out:	
		move.w 	next_x,d0
		add.w 	d0,x_off
		move.w 	next_x1,next_x
		move.w 	d0,next_x1
		addq.w 	#1,rand_x		; random piece for arcade level
		cmp.w 	#11,rand_x
		bne.s 	._y
		move.w 	#1,rand_x
		move.w 	#4,next_x
		move.w 	#4,next_x1
		move.w 	#4,x_off
._y:	addq.w 	#1,rand_y
		cmp.w 	#21,rand_y
		bne.s 	._m
		move.w 	#10,rand_y

._m:
		jsr		musicplayer+8
		jsr		readpad
		jsr		handle_input
		bsr		acia_wrapper

		move.w  #$101,INT1              			; Signal we're done
        move.w  #$0,INT2

		addq.w 	#1,vbl_done		; All systems go!
		
		movem.l	(a7)+,d0-a6 
		rte

block_num:		dc.w 7
doing_sprites:	dc.w 1
ncol:			dc.w 0

		even

; ----------------- constant / variable / buffer list ------------------

ascii:
		.rept 64
		dc.l 0		; font table (movep)
		.endr
		dc.b "00"	; extra score digits
score:		dc.b "0000",-1,-1 ; player score
level:		dc.b "00",-1,-1	  ; player level
levspd:		dc.l 9		; current level speed
start_y:		dc.w 0		; starting height (from top)
lines_done:	dc.w 0		; number of lines made this level
xspeed:		dc.l 0		; drop speed in frames
drops:		dc.w 0		; number of drops made this piece
line_dn:		dc.w 0		; flag for line made or not
on_screen:	dc.l 0		; address of screen of  made line
roller:		dc.w 118	; number of rolls left in credits
rolpos:		dc.l wellpic+34+(9*160)+48	; pointer to roll grafix
well_x:		dc.w 0		; x into ascii table
well_y:		dc.w 0		; y into ascii table
start_offset:	dc.l 0		; vertical distance
address_offset:	dc.l 0		; x/y combination into screen
numtab:		dc.l 0,0,0,0,0,0,0,0,0,0		; table of address of number grafix
next_add:	dc.l 0		; going right addition used with MOVEP
next_sub:	dc.l 0		; going left addition used with MOVEP
wibble:		dc.l 0		; pointer used with the screen buffer
second:		dc.w 0		; offset #1 for MOVEP plotter
third:		dc.w 0		; offset #2 for MOVEP plotter
fourth:		dc.w 0		; offset #3 for MOVEP plotter
screen1:		dc.l 0		; address of screen #1
screen2:		dc.l 0		; address of screen #2
goes:		dc.w 0		; flag used in line checking
dumper:		dc.w 0		; used to clear ikbd bytes
vbl_done:	dc.w 0		; vbl-sync flag
savbuff:
			.rept	12*32
			dc.l	0
			.endr
random_piece:	dc.w 0		; pseudo random counter
current_piece:	dc.l 0		; address of current piece tables
next_shape:	dc.l 0		; just for Andy.....
current_rot:	dc.w 0		; rotational value (0,4,8 or 12)
current_drops:	dc.w 0		; fast drops so far
scoretab:	dc.w 0,10,50	; score for 1,2,3 or 4 lines!
		dc.w 100,200

************************************************************************
*    Attribute table for current piece - must be left in this order    *
************************************************************************
		
width:		dc.w 0		;; width of current shape
height:		dc.w 0		;; height of current shape
character:	dc.l 0,0,0,0		;; positional *'s of current shape
chk1:		dc.l 0,0,0,0,0		;; table of lower co-ordinates
lft1:		dc.l 0,0,0,0,0		;; table of left co-ordinates
rgh1:		dc.l 0,0,0,0,0		;; table of right co-ordinates
rot1:		dc.l 0,0,0,0,0		;; table of next rotation co-ordinates
current_colour:	dc.l 0		;; address of block
first_rotate:	dc.l 0		;; co-ords of first rotation

************************************************************************
******************** Beebris Data Tables Here.. ************************
************************************************************************

piece_table:	dc.l bl1,bl2,bl3,bl4,bl5,bl6,bl7 ; original shapes (classic)
		dc.l bl8,bl9,bla,blb,blc,bld,ble ; new shapes (future-ver)
	
bl1:		dc.l b1r1,b1r2,b1r1,b1r2	; rotation pointers
b1r1:		dc.w 1,3			; width, height
		dc.b " *  "
		dc.b " *  "
		dc.b " *  "
		dc.b " *  "
		dc.w 1,4			; x/y offset to check
		dc.w 1,4			; the bottoms
		dc.w 1,4
		dc.w 1,4
		dc.w 1,4
		dc.w 0,0			; x/y offset to check
		dc.w 0,0			; the lefts			
		dc.w 0,1
		dc.w 0,2
		dc.w 0,3
		dc.w 2,0			; x/y offset to check
		dc.w 2,1			; the rights
		dc.w 2,1			
		dc.w 2,2
		dc.w 2,3
		dc.w 0,0			; the co-ordinates of
		dc.w 1,0			; the next rotation of
		dc.w 1,0			; this shape			
		dc.w 2,0
		dc.w 3,0
		dc.l wellpic+34+136		; address of block (col) 

b1r2:		dc.w 3,0			; width, height
		dc.b "****"
		dc.b "    "
		dc.b "    "
		dc.b "    "
		dc.w 0,1			; x/y offset to check
		dc.w 1,1			; the bottoms
		dc.w 2,1
		dc.w 3,1
		dc.w 3,1
		dc.w -1,0			; x/y offsets to check
		dc.w -1,0			; the lefts
		dc.w -1,0
		dc.w -1,0
		dc.w -1,0
		dc.w 4,0			; x/y offsets to check
		dc.w 4,0			; the rights
		dc.w 4,0
		dc.w 4,0
		dc.w 4,0
		dc.w 1,0			; co-ordinates of
		dc.w 1,1			; next rotation
		dc.w 1,2
		dc.w 1,3
		dc.w 1,3
		dc.l wellpic+34+136

bl2:		dc.l b2r1,b2r2,b2r3,b2r4
b2r1:		dc.w 2,2			; width, height
		dc.b " *  "
		dc.b " ** "
		dc.b " *  "
		dc.b "    "
		dc.w 1,3			; x/y offset to check
		dc.w 2,2			; the bottoms
		dc.w 2,2
		dc.w 2,2
		dc.w 2,2
		dc.w 0,0			; x/y offset to check
		dc.w 0,1			; the lefts
		dc.w 0,2
		dc.w 0,2
		dc.w 0,2
		dc.w 2,0			; x/y offset to check
		dc.w 3,1			; the rights
		dc.w 2,2
		dc.w 2,2
		dc.w 2,2
		dc.w 1,1			; the co-ordinates of
		dc.w 0,2			; the next rotation of
		dc.w 1,2			; this shape
		dc.w 2,2
		dc.w 2,2
		dc.l wellpic+34+136

b2r2:		dc.w 3,2			; width, height
		dc.b "    "
		dc.b " *  "
		dc.b "*** "
		dc.b "    "
		dc.w 0,3			; x/y offset to check
		dc.w 1,3			; the bottoms
		dc.w 2,3
		dc.w 2,3
		dc.w 2,3
		dc.w 0,1			; x/y offset to check
		dc.w -1,2			; the lefts
		dc.w -1,2
		dc.w -1,2
		dc.w -1,2
		dc.w 2,1			; x/y offset to check
		dc.w 3,2			; the rights
		dc.w 3,2
		dc.w 3,2
		dc.w 3,2
		dc.w 2,0			; the co-ordinates of
		dc.w 1,1			; the next rotation of
		dc.w 2,1			; this shape
		dc.w 2,2
		dc.w 2,2
		dc.l wellpic+34+136

b2r3:		dc.w 2,2			; width, height
		dc.b "  * "
		dc.b " ** "
		dc.b "  * "
		dc.b "    "
		dc.w 1,2			; x/y offset to check
		dc.w 2,3			; the bottoms
		dc.w 2,3
		dc.w 2,3
		dc.w 2,3
		dc.w 1,0			; x/y offset to check
		dc.w 0,1			; the lefts
		dc.w 1,2
		dc.w 1,2
		dc.w 1,2
		dc.w 3,0			; x/y offset to check
		dc.w 3,1			; the rights
		dc.w 3,2
		dc.w 3,2
		dc.w 3,2
		dc.w 0,0			; the co-ordinates of
		dc.w 1,0			; the next rotation of
		dc.w 2,0			; this shape
		dc.w 1,1
		dc.w 1,1
		dc.l wellpic+34+136

b2r4:		dc.w 3,1			; width, height
		dc.b "*** "
		dc.b " *  "
		dc.b "    "
		dc.b "    "
		dc.w 0,1			; x/y offset to check
		dc.w 1,2			; the bottoms
		dc.w 2,1
		dc.w 2,1
		dc.w 2,1
		dc.w -1,0			; x/y offset to check
		dc.w 0,1			; the lefts
		dc.w 0,1
		dc.w 0,1
		dc.w 0,1
		dc.w 3,0			; x/y offset to check
		dc.w 2,1			; the rights
		dc.w 2,1
		dc.w 2,1
		dc.w 2,1
		dc.w 1,0			; the co-ordinates of
		dc.w 1,1			; the next rotation of
		dc.w 2,1			; this shape
		dc.w 1,2
		dc.w 1,2
		dc.l wellpic+34+136

bl3:		dc.l b3r1,b3r1,b3r1,b3r1
b3r1:		dc.w 2,1			; width, height
		dc.b " ** "
		dc.b " ** "
		dc.b "    "
		dc.b "    "
		dc.w 1,2			; x/y offset to check
		dc.w 2,2			; the bottoms
		dc.w 2,2
		dc.w 2,2
		dc.w 2,2
		dc.w 0,0			; x/y offset to check
		dc.w 0,1			; the lefts
		dc.w 0,1
		dc.w 0,1
		dc.w 0,1
		dc.w 3,0			; x/y offset to check
		dc.w 3,1			; the rights
		dc.w 3,1
		dc.w 3,1
		dc.w 3,1
		dc.w 1,0			; the co-ordinates of
		dc.w 2,0			; the next rotation of
		dc.w 1,1			; this shape
		dc.w 2,1
		dc.w 2,1
		dc.l wellpic+34+140

bl4:		dc.l b4r1,b4r2,b4r1,b4r2
b4r1:		dc.w 2,1			; width, height
		dc.b " ** "
		dc.b "**  "
		dc.b "    "
		dc.b "    "
		dc.w 0,2			; x/y offset to check
		dc.w 1,2			; the bottoms
		dc.w 2,1
		dc.w 2,1
		dc.w 2,1
		dc.w 0,0			; x/y offset to check
		dc.w -1,1			; the lefts
		dc.w 0,0
		dc.w 0,0
		dc.w 0,0
		dc.w 3,0			; x/y offset to check
		dc.w 2,1			; the rights
		dc.w 2,1
		dc.w 2,1
		dc.w 2,1
		dc.w 1,0			; the co-ordinates of
		dc.w 1,1			; the next rotation of
		dc.w 2,1			; this shape
		dc.w 2,2
		dc.w 2,2
		dc.l wellpic+34+144

b4r2:		dc.w 2,2			; width, height
		dc.b " *  "
		dc.b " ** "
		dc.b "  * "
		dc.b "    "
		dc.w 1,2			; x/y offset to check
		dc.w 2,3			; the bottoms
		dc.w 2,3
		dc.w 2,3
		dc.w 2,3
		dc.w 0,0			; x/y offset to check
		dc.w 0,1			; the lefts
		dc.w 1,2
		dc.w 1,2
		dc.w 1,2
		dc.w 2,0			; x/y offset to check
		dc.w 3,1			; the rights
		dc.w 3,2
		dc.w 3,2
		dc.w 3,2
		dc.w 1,0			; the co-ordinates of
		dc.w 2,0			; the next rotation of
		dc.w 0,1			; this shape
		dc.w 1,1
		dc.w 1,1
		dc.l wellpic+34+144

bl5:		dc.l b5r1,b5r2,b5r1,b5r2
b5r1:		dc.w 2,1			; width, height
		dc.b "**  "
		dc.b " ** "
		dc.b "    "
		dc.b "    "
		dc.w 0,1			; x/y offset to check
		dc.w 1,2			; the bottoms
		dc.w 2,2
		dc.w 2,2
		dc.w 2,2
		dc.w -1,0			; x/y offset to check
		dc.w 0,1			; the lefts
		dc.w 0,1
		dc.w 0,1
		dc.w 0,1
		dc.w 2,0			; x/y offset to check
		dc.w 3,1			; the rights
		dc.w 3,1
		dc.w 3,1
		dc.w 3,1
		dc.w 1,0			; the co-ordinates of
		dc.w 0,1			; the next rotation of
		dc.w 1,1			; this shape
		dc.w 0,2
		dc.w 0,2
		dc.l wellpic+34+148

b5r2:		dc.w 2,1			; width, height
		dc.b " *  "
		dc.b "**  "
		dc.b "*   "
		dc.b "    "
		dc.w 0,3			; x/y offset to check
		dc.w 1,2			; the bottoms
		dc.w 1,2
		dc.w 1,2
		dc.w 1,2
		dc.w 0,0			; x/y offset to check
		dc.w -1,1			; the lefts
		dc.w -1,2
		dc.w -1,2
		dc.w -1,2
		dc.w 2,0			; x/y offset to check
		dc.w 2,1			; the rights
		dc.w 1,2
		dc.w 1,2
		dc.w 1,2
		dc.w 0,0			; the co-ordinates of
		dc.w 1,0			; the next rotation of
		dc.w 1,1			; this shape
		dc.w 2,1
		dc.w 2,1
		dc.l wellpic+34+148

bl6:		dc.l b6r1,b6r2,b6r3,b6r4
b6r1:		dc.w 2,1			; width, height
		dc.b "*** "
		dc.b "*   "
		dc.b "    "
		dc.b "    "
		dc.w 0,2			; x/y offset to check
		dc.w 1,1			; the bottoms
		dc.w 2,1
		dc.w 2,1
		dc.w 2,1
		dc.w -1,0			; x/y offset to check
		dc.w -1,1			; the lefts
		dc.w -1,1
		dc.w -1,1
		dc.w -1,1
		dc.w 3,0			; x/y offset to check
		dc.w 1,1			; the rights
		dc.w 1,1
		dc.w 1,1
		dc.w 1,1
		dc.w 0,0			; the co-ordinates of
		dc.w 0,1			; the next rotation of
		dc.w 0,2			; this shape
		dc.w 1,2
		dc.w 1,2
		dc.l wellpic+34+152

b6r2:		dc.w 2,1			; width, height
		dc.b "*   "
		dc.b "*   "
		dc.b "**  "
		dc.b "    "
		dc.w 0,3			; x/y offset to check
		dc.w 1,3			; the bottoms
		dc.w 1,3
		dc.w 1,3
		dc.w 1,3
		dc.w -1,0			; x/y offset to check
		dc.w -1,1			; the lefts
		dc.w -1,2
		dc.w -1,2
		dc.w -1,2
		dc.w 1,0			; x/y offset to check
		dc.w 1,1			; the rights
		dc.w 2,2
		dc.w 2,2
		dc.w 2,2
		dc.w 2,1			; the co-ordinates of
		dc.w 2,2			; the next rotation of
		dc.w 1,2			; this shape
		dc.w 0,2
		dc.w 0,2
		dc.l wellpic+34+152

b6r3:		dc.w 2,1			; width, height
		dc.b "    "
		dc.b "  * "
		dc.b "*** "
		dc.b "    "
		dc.w 0,3			; x/y offset to check
		dc.w 1,3			; the bottoms
		dc.w 2,3
		dc.w 2,3
		dc.w 2,3
		dc.w 1,1			; x/y offset to check
		dc.w -1,2			; the lefts
		dc.w -1,2
		dc.w -1,2
		dc.w -1,2
		dc.w 3,1			; x/y offset to check
		dc.w 3,1			; the rights
		dc.w 3,2
		dc.w 3,2
		dc.w 3,2
		dc.w 0,0			; the co-ordinates of
		dc.w 1,0			; the next rotation of
		dc.w 1,1			; this shape
		dc.w 1,2
		dc.w 1,2
		dc.l wellpic+34+152

b6r4:		dc.w 2,1			; width, height
		dc.b "**  "
		dc.b " *  "
		dc.b " *  "
		dc.b "    "
		dc.w 0,1			; x/y offset to check
		dc.w 1,3			; the bottoms
		dc.w 1,3
		dc.w 1,3
		dc.w 1,3
		dc.w -1,0			; x/y offset to check
		dc.w 0,1			; the lefts
		dc.w 0,2
		dc.w 0,2
		dc.w 0,2
		dc.w 2,0			; x/y offset to check
		dc.w 2,1			; the rights
		dc.w 2,2
		dc.w 2,2
		dc.w 2,2
		dc.w 0,0			; the co-ordinates of
		dc.w 1,0			; the next rotation of
		dc.w 2,0			; this shape
		dc.w 0,1
		dc.w 0,1
		dc.l wellpic+34+152

bl7:		dc.l b7r1,b7r2,b7r3,b7r4
b7r1:		dc.w 2,1			; width, height
		dc.b "    "
		dc.b "*   "
		dc.b "*** "
		dc.b "    "
		dc.w 0,3			; x/y offset to check
		dc.w 1,3			; the bottoms
		dc.w 2,3
		dc.w 2,3
		dc.w 2,3
		dc.w -1,1			; x/y offset to check
		dc.w -1,2			; the lefts
		dc.w -1,2
		dc.w -1,2
		dc.w -1,2
		dc.w 1,1			; x/y offset to check
		dc.w 3,2			; the rights
		dc.w 3,2
		dc.w 3,2
		dc.w 3,2
		dc.w 2,0			; the co-ordinates of
		dc.w 2,1			; the next rotation of
		dc.w 2,2			; this shape
		dc.w 1,2
		dc.w 1,2
		dc.l wellpic+34+156

b7r2:		dc.w 2,1			; width, height
		dc.b "  * "
		dc.b "  * "
		dc.b " ** "
		dc.b "    "
		dc.w 1,3			; x/y offset to check
		dc.w 2,3			; the bottoms
		dc.w 2,3
		dc.w 2,3
		dc.w 2,3
		dc.w 0,2			; x/y offset to check
		dc.w 1,0			; the lefts
		dc.w 1,1
		dc.w 1,1
		dc.w 1,1
		dc.w 3,0			; x/y offset to check
		dc.w 3,1			; the rights
		dc.w 3,2
		dc.w 3,2
		dc.w 3,2
		dc.w 0,0			; the co-ordinates of
		dc.w 1,0			; the next rotation of
		dc.w 2,0			; this shape
		dc.w 2,1
		dc.w 2,1
		dc.l wellpic+34+156

b7r3:		dc.w 2,1			; width, height
		dc.b "*** "
		dc.b "  * "
		dc.b "    "
		dc.b "    "
		dc.w 0,1			; x/y offset to check
		dc.w 1,1			; the bottoms
		dc.w 2,2
		dc.w 2,2
		dc.w 2,2
		dc.w -1,0			; x/y offset to check
		dc.w 1,1			; the lefts
		dc.w 1,1
		dc.w 1,1
		dc.w 1,1
		dc.w 3,0			; x/y offset to check
		dc.w 3,1			; the rights
		dc.w 3,1
		dc.w 3,1
		dc.w 3,1
		dc.w 0,0			; the co-ordinates of
		dc.w 1,0			; the next rotation of
		dc.w 0,1			; this shape
		dc.w 0,2
		dc.w 0,2
		dc.l wellpic+34+156

b7r4:		dc.w 2,1			; width, height
		dc.b "**  "
		dc.b "*   "
		dc.b "*   "
		dc.b "    "
		dc.w 0,3			; x/y offset to check
		dc.w 1,1			; the bottoms
		dc.w 1,1
		dc.w 1,1
		dc.w 1,1
		dc.w -1,0			; x/y offset to check
		dc.w -1,1			; the lefts
		dc.w -1,2
		dc.w -1,2
		dc.w -1,2
		dc.w 2,0			; x/y offset to check
		dc.w 1,1			; the rights
		dc.w 1,2
		dc.w 1,2
		dc.w 1,2
		dc.w 0,1			; the co-ordinates of
		dc.w 0,2			; the next rotation of
		dc.w 1,2			; this shape
		dc.w 2,2
		dc.w 2,2
		dc.l wellpic+34+156

;;;;;;;;;;;; the new pieces are from here down ;;;;;;;;;;;;;;;

bl8:		dc.l b8r1,b8r1,b8r1,b8r1
b8r1:		dc.w 2,1			; skip header
		dc.b " *  "
		dc.b "*** "
		dc.b " *  "
		dc.b "    "
		dc.w 0,2			; bottoms
		dc.w 1,3
		dc.w 2,2
		dc.w 1,1
		dc.w 0,0
		dc.w 0,0			; lefts
		dc.w -1,1
		dc.w 0,2
		dc.w 1,1
		dc.w 0,2
		dc.w 2,0			; rights
		dc.w 1,1
		dc.w 3,1
		dc.w 2,2
		dc.w 2,2
		dc.w 1,0			; next rot
		dc.w 0,1
		dc.w 2,1
		dc.w 1,2
		dc.w 1,1
		dc.l wellpic+34+136

bl9:		dc.l b9r1,b9r2,b9r3,b9r4
b9r1:		dc.w 2,1			; skip header
		dc.b "* * "
		dc.b "*** "
		dc.b "    "
		dc.b "    "
		dc.w 0,2			; bottoms
		dc.w 1,2
		dc.w 2,2
		dc.w 2,2
		dc.w 2,2
		dc.w -1,0			; lefts
		dc.w -1,1
		dc.w -1,1
		dc.w -1,1
		dc.w -1,1
		dc.w 3,0			; rights
		dc.w 3,1
		dc.w 3,1
		dc.w 3,1
		dc.w 3,1
		dc.w 1,0			; next rot
		dc.w 2,0
		dc.w 2,1
		dc.w 2,2
		dc.w 1,2
		dc.l wellpic+34+140

b9r2:		dc.w 2,1			; skip header
		dc.b " ** "
		dc.b "  * "
		dc.b " ** "
		dc.b "    "
		dc.w 1,3			; bottoms
		dc.w 2,3
		dc.w 2,3
		dc.w 2,3
		dc.w 2,3
		dc.w 0,0			; lefts
		dc.w 1,1
		dc.w 0,2
		dc.w 0,2
		dc.w 0,2
		dc.w 3,0			; rights
		dc.w 3,1
		dc.w 3,2
		dc.w 3,1
		dc.w 3,1
		dc.w 0,0			; next rot
		dc.w 1,0
		dc.w 2,0
		dc.w 0,1
		dc.w 2,1
		dc.l wellpic+34+140

b9r3:		dc.w 2,1			; skip header
		dc.b "*** "
		dc.b "* * "
		dc.b "    "
		dc.b "    "
		dc.w 0,2			; bottoms
		dc.w 1,1
		dc.w 2,2
		dc.w 2,2
		dc.w 2,2
		dc.w -1,0			; lefts
		dc.w -1,1
		dc.w -1,1
		dc.w -1,1
		dc.w -1,1
		dc.w 3,0			; rights
		dc.w 3,1
		dc.w 3,1
		dc.w 3,1
		dc.w 3,1
		dc.w 0,0			; next rot
		dc.w 1,0
		dc.w 0,1
		dc.w 0,2
		dc.w 1,2
		dc.l wellpic+34+140

b9r4:		dc.w 2,1			; skip header
		dc.b "**  "
		dc.b "*   "
		dc.b "**  "
		dc.b "    "
		dc.w 0,3			; bottoms
		dc.w 1,3
		dc.w 1,3
		dc.w 1,3
		dc.w 1,3
		dc.w -1,0			; lefts
		dc.w -1,1
		dc.w -1,2
		dc.w -1,1
		dc.w -1,1
		dc.w 2,0			; rights
		dc.w 1,1
		dc.w 2,2
		dc.w 2,2
		dc.w 2,2
		dc.w 0,0			; next rot
		dc.w 0,1
		dc.w 1,1
		dc.w 2,1
		dc.w 2,0
		dc.l wellpic+34+140

bla:		dc.l bar1,bar2,bar1,bar2
bar1:		dc.w 2,1			; skip header
		dc.b "  * "
		dc.b " *  "
		dc.b "*   "
		dc.b "    "
		dc.w 0,3			; bottoms
		dc.w 1,2
		dc.w 2,1
		dc.w 2,1
		dc.w 2,1
		dc.w 1,0			; lefts
		dc.w 0,1
		dc.w -1,2
		dc.w -1,2
		dc.w -1,2
		dc.w 3,0			; rights
		dc.w 2,1
		dc.w 1,2
		dc.w 1,2
		dc.w 1,2
		dc.w 0,0			; next rot
		dc.w 1,1
		dc.w 2,2
		dc.w 2,2
		dc.w 2,2
		dc.l wellpic+34+144

bar2:		dc.w 2,1			; skip header
		dc.b "*   "
		dc.b " *  "
		dc.b "  * "
		dc.b "    "
		dc.w 0,1			; bottoms
		dc.w 1,2
		dc.w 2,3
		dc.w 2,3
		dc.w 2,3
		dc.w -1,0			; lefts
		dc.w 0,1
		dc.w 1,2
		dc.w 1,2
		dc.w 1,2
		dc.w 1,0			; rights
		dc.w 2,1
		dc.w 3,2
		dc.w 3,2
		dc.w 3,2
		dc.w 2,0			; next rot
		dc.w 1,1
		dc.w 0,2
		dc.w 0,2
		dc.w 0,2
		dc.l wellpic+34+144

blb:		dc.l bbr1,bbr2,bbr1,bbr2
bbr1:		dc.w 2,1			; skip header
		dc.b "**  "
		dc.b " *  "
		dc.b " ** "
		dc.b "    "
		dc.w 0,1			; bottoms
		dc.w 1,3
		dc.w 2,3
		dc.w 2,3
		dc.w 2,3
		dc.w -1,0			; lefts
		dc.w 0,1
		dc.w 0,2
		dc.w 0,2
		dc.w 0,2
		dc.w 2,0			; rights
		dc.w 2,1
		dc.w 3,2
		dc.w 3,2
		dc.w 3,2
		dc.w 2,0			; next rot
		dc.w 0,1
		dc.w 1,1
		dc.w 2,1
		dc.w 0,2
		dc.l wellpic+34+148

bbr2:		dc.w 2,1			; skip header
		dc.b "  * "
		dc.b "*** "
		dc.b "*   "
		dc.b "    "
		dc.w 0,3			; bottoms
		dc.w 1,2
		dc.w 2,2
		dc.w 2,2
		dc.w 2,2
		dc.w 1,0			; lefts
		dc.w -1,1
		dc.w -1,2
		dc.w -1,2
		dc.w -1,2
		dc.w 3,0			; rights
		dc.w 3,1
		dc.w 1,2
		dc.w 1,2
		dc.w 1,2
		dc.w 0,0			; next rot
		dc.w 1,0
		dc.w 1,1
		dc.w 1,2
		dc.w 2,2
		dc.l wellpic+34+148

blc:		dc.l bcr1,bcr2,bcr1,bcr2
bcr1:		dc.w 2,1			; skip header
		dc.b " *  "
		dc.b "*   "
		dc.b "    "
		dc.b "    "
		dc.w 0,2			; bottoms
		dc.w 1,1
		dc.w 1,1
		dc.w 1,1
		dc.w 1,1
		dc.w 0,0			; lefts
		dc.w -1,1
		dc.w -1,1
		dc.w -1,1
		dc.w -1,1
		dc.w 2,0			; rights
		dc.w 1,1
		dc.w 1,1
		dc.w 1,1
		dc.w 1,1
		dc.w 0,0			; next rot
		dc.w 1,1
		dc.w 1,1
		dc.w 1,1
		dc.w 1,1
		dc.l wellpic+34+152

bcr2:		dc.w 2,1			; skip header
		dc.b "*   "
		dc.b " *  "
		dc.b "    "
		dc.b "    "
		dc.w 0,1			; bottoms
		dc.w 1,2
		dc.w 1,2
		dc.w 1,2
		dc.w 1,2
		dc.w -1,0			; lefts
		dc.w 0,1
		dc.w 0,1
		dc.w 0,1
		dc.w 0,1
		dc.w 1,0			; rights
		dc.w 2,1
		dc.w 2,1
		dc.w 2,1
		dc.w 2,1
		dc.w 1,0			; next rot
		dc.w 0,1
		dc.w 0,1
		dc.w 0,1
		dc.w 0,1
		dc.l wellpic+34+152

bld:		dc.l bdr1,bdr1,bdr1,bdr1
bdr1:		dc.w 2,1			; skip header
		dc.b "*   "
		dc.b "    "
		dc.b "    "
		dc.b "    "
		dc.w 0,1			; bottoms
		dc.w 0,1
		dc.w 0,1
		dc.w 0,1
		dc.w 0,1
		dc.w -1,0			; lefts
		dc.w -1,0
		dc.w -1,0
		dc.w -1,0
		dc.w -1,0
		dc.w 1,0			; rights
		dc.w 1,0
		dc.w 1,0
		dc.w 1,0
		dc.w 1,0
		dc.w 0,0			; next rot
		dc.w 0,0
		dc.w 0,0
		dc.w 0,0
		dc.w 0,0
		dc.l wellpic+34+156

ble:		dc.l ber1,ber2,ber1,ber2
ber1:		dc.w  2,1			; skip header
		dc.b " ** "
		dc.b " *  "
		dc.b "**  "
		dc.b "    "
		dc.w 0,3			; bottoms
		dc.w 1,3
		dc.w 2,1
		dc.w 2,1
		dc.w 2,1
		dc.w 0,0			; lefts
		dc.w 0,1
		dc.w -1,2
		dc.w -1,2
		dc.w -1,2
		dc.w 3,0			; rights
		dc.w 2,1
		dc.w 2,2
		dc.w 2,2
		dc.w 2,2
		dc.w 0,0			; next rot
		dc.w 0,1
		dc.w 1,1
		dc.w 2,1
		dc.w 2,2
		dc.l wellpic+34+136

ber2:		dc.w  2,1			; skip header
		dc.b "*   "
		dc.b "*** "
		dc.b "  * "
		dc.b "    "
		dc.w 0,2			; bottoms
		dc.w 1,2
		dc.w 2,3
		dc.w 2,3
		dc.w 2,3
		dc.w -1,0			; lefts
		dc.w -1,1
		dc.w 1,2
		dc.w 1,2
		dc.w 1,2
		dc.w 1,0			; rights
		dc.w 3,1
		dc.w 3,2
		dc.w 3,2
		dc.w 3,2
		dc.w 1,0			; next rot
		dc.w 2,0
		dc.w 1,1
		dc.w 1,2
		dc.w 0,2
		dc.l wellpic+34+136

; ------------------------ The Well! In Ascii form ---------------------

		dc.b "*          *"		; these top four
		dc.b "*          *"		; rows are to fix
		dc.b "*          *"		; a bug without
		dc.b "*          *"		; a major re-write!
well:		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
		dc.b "*          *"	
well_bot:	dc.b "*          *"	
		dc.b "************"
		even
		
do_webcode_display:
		bsr		generate_webcode
		
		lea		webgfx,a0
		lea		web_code,a1
		jsr		info2
		
		move.l	webbox_obj,a0
		move.l	#17+104,d0
		move.l	#120,d1
		bsr		setup_object_xy
		
		move.l	web_obj,a0
		move.l	#17+104+20,d0
		move.l	#133,d1
		bsr		setup_object_xy
		
.holdloop:
		jsr		readpad
		jsr		handle_input
		
		tst.w	dpad_b
		beq		.holdloop
.release_loop:
		jsr		readpad
		jsr		handle_input
		tst.w	dpad_b
		bne		.release_loop
		
		move.l	web_obj,a0
		move.l	#700,d0
		move.l	#700,d1
		bsr		setup_object_xy
		
		move.l	webbox_obj,a0
		move.l	#700,d0
		move.l	#700,d1
		bsr		setup_object_xy		
		rts
		
		include "score.s"
		.phrase
		
tracking_vbl:
		move.l	#6,d7				; 7 sprites
		lea		tracking_objs,a6
		move.l	#24,d6				; offset to pointer
		
.trkloop:
		move.l	(a6)+,a0			; object address
		lea		trackx,a1
		move.l	(a1,d6.w),a2		; get x-ptr
		move.w	(a2)+,d0
		cmp.l	#trk_xe,a2
		bne.s	.str_x
		lea		trk_x+2,a2
.str_x:	move.l	a2,(a1,d6.w)		; write new ptr

		lea		tracky,a1
		move.l	(a1,d6.w),a2
		move.w	(a2)+,d1
		cmp.l	#trk_ye,a2
		bne.s	.str_y
		lea		trk_y+2,a2
.str_y:	move.l	a2,(a1,d6.w)
	
		subq	#4,d6
		divu	#160,d1
		add.l	#217,d1
		add.l	#17,d0				; 

		tst.w	bouncing_flag
		beq.s	.nobnc
		add.l	#8,d1
.nobnc:
		movem.l	d0-a6,-(a7)
		bsr		setup_object_xy
		movem.l	(a7)+,d0-a6
		
		dbra	d7,.trkloop
		
		rts
		
tracking_objs:	dc.l	0,0,0,0,0,0,0,0

trackx:	dc.l trk_x+208,trk_x+192,trk_x+176				; bee
		dc.l trk_x+160,trk_x+144,trk_x+128,trk_x+112	; bris
	 
trk_x:	incbin "sprites/trk_x.bin"
trk_xe:	dc.l	0

tracky:	dc.l trk_y+208,trk_y+192,trk_y+176				; bee
		dc.l trk_y+160,trk_y+144,trk_y+128,trk_y+112	; bris

trk_y:	incbin "sprites/trk_y.bin"
trk_ye:	dc.l	0

		.phrase
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Create the initial object list.
;;

bitmapobject    equ 0            ; object types
scaledobject    equ 1
gpuobject       equ 2
braobject       equ 3             
stopobject      equ 4

y_less          equ 0            ; branch object types
y_more          equ 1
always          equ 2

; D1=branch type
; D2=Ypos
; A1=address if branch TAKEN

MakeObjectList: lea     ob_list1,a0             			; start of OL
                jsr     build_header            			; build BRA header

				move.l	a0,backdrop_obj						; store object address in table
				move.l	#backdrop,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #256,d1 	                 		; height
                move.l  #360*2,d2	             				; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #0,d4                   			; non transparent
				move.l	#360*2,d5
                jsr     CreateObject

				move.l	a0,well_obj						; store object address in table
				move.l	#tetwell,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #193,d1 	                 		; height
                move.l  #104*2,d2	             			; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #1,d4                   			; non transparent
				move.l	#104*2,d5
                jsr     CreateObject

				move.l	a0,scoremask_obj
				move.l	#scoremask,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #108,d1 	                 		; height
                move.l  #200*2,d2	             				; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #0,d4                   			; non transparent
				move.l	#200*2,d5
                jsr     CreateObject
				
				move.l	a0,screen_obj						; store object address in table
				move.l	#lowscreen,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #200,d1 	                 		; height
                move.l  #160,d2	             				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #1,d4                   			; transparent
				move.l	#160,d5
                jsr     CreateObject

				move.l	a0,newtris_obj						; store object address in table
				move.l	#newtris,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #60,d1 	                 		; height
                move.l  #208*2,d2	             				; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #0,d4                   			; non transparent
				move.l	#208*2,d5
                jsr     CreateObject

				move.l	a0,webbox_obj
				move.l	#webboxgfx,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #36,d1 	                 			; height
                move.l  #112*2,d2	             				; bytes to next line
                move.l  #4,d3                   			; 16-Bit
                move.l  #0,d4                   			; transparent
				move.l	#112*2,d5
                jsr     CreateObject
								
				move.l	a0,web_obj						; store object address in table
				move.l	#webgfx,a1
				move.l  #bitmapobject,d0        			; type
                move.l  #8,d1 	                 			; height
                move.l  #40,d2	             				; bytes to next line
                move.l  #0,d3                   			; 1-Bit
                move.l  #1,d4                   			; transparent
				move.l	#40,d5
                jsr     CreateObject
				move.l	web_obj,a1					; pointer to object
				and.w	#%1110000000111111,10(a1)			; mask out index
				or.w	#%0000010000000000,10(a1)			; or in next index (Pal 2)		
				move.w	#$ffff,$f00402+(16*2*2)
	
				move.l	a0,lowborder_obj						; store object address in table
				move.l	#lowscreen+(160*200),a1
				move.l  #bitmapobject,d0        			; type
                move.l  #56,d1 	                 		; height
                move.l  #160,d2	             				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #1,d4                   			; transparent
				move.l	#160,d5
                jsr     CreateObject
				move.l	lowborder_obj,a1					; pointer to object
				and.w	#%1110000000111111,10(a1)			; mask out index
				or.w	#%0000001000000000,10(a1)			; or in next index (Pal 1)		
; b +0
; e +8
; r +16
; i +24
; s +32		
				lea		tracking_objs,a6					; E
				move.l	a0,(a6)
				move.l	#copybitmap+48+(160*26),a1
				move.l  #bitmapobject,d0        			; type
                move.l  #16,d1 	                 			; height
                move.l  #160,d2	             				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #1,d4                   			; transparent
				move.l	#8,d5
				move.l	a6,-(a7)
                jsr     CreateObject
				move.l	(a7)+,a6
				move.l	(a6)+,a1							; pointer to object
				and.w	#%1110000000111111,10(a1)			; mask out index
				or.w	#%0000001000000000,10(a1)			; or in next index (Pal 1)		

				move.l	a0,(a6)								; T
				move.l	#copybitmap+40+(160*26),a1
				move.l  #bitmapobject,d0        			; type
                move.l  #16,d1 	                 			; height
                move.l  #160,d2	             				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #1,d4                   			; transparent
				move.l	#8,d5
				move.l	a6,-(a7)
                jsr     CreateObject
				move.l	(a7)+,a6
				move.l	(a6)+,a1							; pointer to object
				and.w	#%1110000000111111,10(a1)			; mask out index
				or.w	#%0000001000000000,10(a1)			; or in next index (Pal 1)
				
				move.l	a0,(a6)								; U
				move.l	#copybitmap+32+(160*26),a1
				move.l  #bitmapobject,d0        			; type
                move.l  #16,d1 	                 			; height
                move.l  #160,d2	             				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #1,d4                   			; transparent
				move.l	#8,d5
				move.l	a6,-(a7)
                jsr     CreateObject
				move.l	(a7)+,a6
				move.l	(a6)+,a1							; pointer to object
				and.w	#%1110000000111111,10(a1)			; mask out index
				or.w	#%0000001000000000,10(a1)			; or in next index (Pal 1)		

				move.l	a0,(a6)								; B
				move.l	#copybitmap+24+(160*26),a1
				move.l  #bitmapobject,d0        			; type
                move.l  #16,d1 	                 			; height
                move.l  #160,d2	             				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #1,d4                   			; transparent
				move.l	#8,d5
				move.l	a6,-(a7)
                jsr     CreateObject
				move.l	(a7)+,a6
				move.l	(a6)+,a1							; pointer to object
				and.w	#%1110000000111111,10(a1)			; mask out index
				or.w	#%0000001000000000,10(a1)			; or in next index (Pal 1)		

				move.l	a0,(a6)								; I
				move.l	#copybitmap+16+(160*26),a1
				move.l  #bitmapobject,d0        			; type
                move.l  #16,d1 	                 			; height
                move.l  #160,d2	             				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #1,d4                   			; transparent
				move.l	#8,d5
				move.l	a6,-(a7)
                jsr     CreateObject
				move.l	(a7)+,a6
				move.l	(a6)+,a1							; pointer to object
				and.w	#%1110000000111111,10(a1)			; mask out index
				or.w	#%0000001000000000,10(a1)			; or in next index (Pal 1)		

				move.l	a0,(a6)								; R
				move.l	#copybitmap+8+(160*26),a1
				move.l  #bitmapobject,d0        			; type
                move.l  #16,d1 	                 			; height
                move.l  #160,d2	             				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #1,d4                   			; transparent
				move.l	#8,d5
				move.l	a6,-(a7)
                jsr     CreateObject
				move.l	(a7)+,a6
				move.l	(a6)+,a1							; pointer to object
				and.w	#%1110000000111111,10(a1)			; mask out index
				or.w	#%0000001000000000,10(a1)			; or in next index (Pal 1)		

				move.l	a0,(a6)								; T
				move.l	#copybitmap+(160*26),a1
				move.l  #bitmapobject,d0        			; type
                move.l  #16,d1 	                 			; height
                move.l  #160,d2	             				; bytes to next line
                move.l  #2,d3                   			; 4-Bit
                move.l  #1,d4                   			; transparent
				move.l	#8,d5
				move.l	a6,-(a7)
                jsr     CreateObject
				move.l	(a7)+,a6
				move.l	(a6)+,a1							; pointer to object
				and.w	#%1110000000111111,10(a1)			; mask out index
				or.w	#%0000001000000000,10(a1)			; or in next index (Pal 1)		

				move.l	#stopobject,d0
				jsr		CreateObject
				
				move.l	web_obj,a0
				move.l	#700,d0
				move.l	#700,d1
				bsr		setup_object_xy
				move.l	webbox_obj,a0
				move.l	#700,d0
				move.l	#700,d1
				bsr		setup_object_xy				
				rts
				
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Copy Object List Routine
;;

copy_olist:
				move.l	#ob_list,A1_BASE
				move.l	#$0,A1_PIXEL
				move.l	#PIXEL16|XADDPHR|PITCH1,A1_FLAGS
				move.l	#ob_list1,A2_BASE
				move.l	#$0,A2_PIXEL
				move.l	#PIXEL16|XADDPHR|PITCH1,A2_FLAGS
				move.w	#1,d0
				swap	d0
				move.w	#$2000/2,d0
				move.l	d0,B_COUNT
				move.l	#LFU_REPLACE|SRCEN,B_CMD
				rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Build a header that'll STOP if VPOS not on screen.
;;

build_header:   move.l  a0,d0               ; address if bra not taken
                sub.l   #ob_list1,d0        ;
                add.l   #ob_list,d0         ;
                add.l   #32,d0              ; next BRA object
                lsr.l   #3,d0               ;
                lsl.l   #8,d0               ;
                clr.l   (a0)                ;
                move.l  #$00008003,4(a0)    ; bra if yp<0
                or.l    d0,2(a0)            ; link to next BRA
                lea     8(a0),a0            ;
                bsr     stopob              ; write stop object (before top)
                lea     16(a0),a0           ; next object here

                move.l  a0,d0               ; calc address of 1st actual
                sub.l   #ob_list1,d0        ; object (after the next STOP)
                add.l   #ob_list,d0         ;
                add.l   #32,d0              ;
                lsr.l   #3,d0               ;
                lsl.l   #8,d0               ;
                clr.l   (a0)                ;
                move.l  #$00004003,4(a0)    ; bra is yp>value
                or.l    d0,2(a0)            ; link to first object!

				move.w	CONFIG,d6
				andi.w	#VIDTYPE,d6
				beq		.pal
				move.l	#498,d0				; 492 lines = full NTSC frame
				bra		.ntsc
.pal:			move.l	#570,d0				; 580 lines = full PAL frame
.ntsc:          lsl.l   #3,d0               ;
                or.l    d0,4(a0)            ;
                lea     8(a0),a0            ; next object
                bsr     stopob              ; is a STOP
				lea     16(a0),a0           ; address for next REAL object

                rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Simple Object List Routines for a simple life.
;;
;; call with *d0=object type
;;           *d1=height
;;           *d2=data width
;;           *d3=colour depth
;;           *d4=transparent
;;           *d5=image width
;;           *a0=address of object (phrase alligned)
;;           *a1=address for GFX   (phrase alligned)
;;
;; exit with object built
;;           link=object address+32
;;           scaled objects will *NOT* be 1:1 in x/y
;;           x/y positions will be -500,2 (off screen)
;;

CreateObject:   lsl.w   #2,d0                   ; object type
                move.l  jmp_tab(pc,d0),a6       ; get routine address
                jmp (a6)                        ; call it!

jmp_tab:        .dc.l bitmp                     ; jump table
                .dc.l scaled
                .dc.l gpuob
                .dc.l braob
                .dc.l stopob

bitmp:          clr.l   (a0)                    ; template
                clr.l   4(a0)                   ;
                clr.l   8(a0)                   ;
                move.l  #$00008000,12(a0)       ;
                move.l  a0,d0                   ; link address
                sub.l   #ob_list1,d0            ;
                add.l   #ob_list,d0             ;
                add.l   #32,d0                  ;
                and.b   #%11111000,d0           ;
                lsl.l   #5,d0                   ;
                or.l    d0,2(a0)                ;
                move.l  a1,d0                   ; gfx address
                lsl.l   #8,d0                   ;
                or.l    d0,(a0)                 ;
                move.l  d1,d0                   ; height
                swap    d0                      ;
                lsr.l   #2,d0                   ;
                or.l    d0,4(a0)                ;
                ror.w   #1,d4                   ; transparency
                or.w    d4,10(a0)               ;
                lsl.w   #8,d3                   ; depth (colour depth)
                lsl.w   #4,d3                   ;
                or.w    d3,14(a0)               ;
                lsr.w   #3,d2                   ; data width
                swap    d2                      ;
                lsl.l   #2,d2                   ;
                or.l    d2,12(a0)               ;
                lsr.w   #3,d5                   ; image width
                swap    d5                      ;
                lsr.l   #4,d5                   ;
                or.l    d5,10(a0)               ;
                move.w  #-500,d0                ; x-pos
                and.w   #$fff,d0
                or.w    d0,14(a0)
                or.w    #2*8,6(a0)              ; y-pos
                lea     32(a0),a0               ; BITMAP object!
                rts

scaled:         bsr     bitmp                   ; same as bitmap
                move.l  #$0,-16(a0)             ; clear it out
                move.l  #%00000000000000000100000001000000,-12(a0)
                or.l    #$1,-28(a0)             ; SCALED object!
                rts

gpuob:          move.l  #0,(a0)+
                move.l  #$3ffa,(a0)+            ; GPU object!
                rts

				
; D1=branch type
; D2=Ypos
; A1=address if branch TAKEN
				
braob:          add     d2,d2                   ; mult y-pos
                bsr     branchobject            ; make the object
make8into32:    move.l  #braobject,d0           ;
                move.l  #always,d1              ; even it out for 32-byte
                move.l  #$7ff,d2                ; positions by following with
                lea     24(a0),a1               ; a BRA+16 object
                bsr     branchobject            ;
                lea     16(a0),a0               ;
                rts

branchobject:   clr.l   (a0)
                move.l  #3,4(a0)
                add.w   d1,d1
                move.w  branchtypes(pc,d1.w),d1
                or.w    d1,6(a0)                ; branch TYPE!
                move.l  a1,d0
                sub.l   #ob_list1,d0
                add.l   #ob_list,d0
                and.l   #$fffffff8,d0
                lsl.l   #5,d0                   ; Link if branch **TAKEN!**
                move.l  d0,2(a0)                ; (< & > swapped!)
                lsl.w   #3,d2                   ; scanline to branch on
                or.w    d2,6(a0)                ; is VC/2
                lea     8(a0),a0                ; next object
                rts

branchtypes:    .dc.w    $4000,$8000,$0000       ; (< & > inverted for ease!)

stopob:         move.l  #0,(a0)+
                move.l  #4,(a0)+                ; STOP object!
                rts				

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; set object pointed to by (a0) to new x/y position and bitmap in d2
;;
;;
;; a0=object list data
;; d0=x
;; d1=y
;; d2=bitmap address
;;
				
setup_object_xyg: 
			tst.w ntsc_flag
			bpl.s	.offsdone
			add.w	#20,d1

.offsdone:		and.w	#%111111111111,d0					; mask x value only (for negatives)
				and.w	#%1111111111,d1						; and again (y)
				move.w  6(a0),d4                			; get y-pos
               and.w   #$c007,d4
               move.w  14(a0),d6               			; get x-pos
               and.w   #$f000,d6
                add.w   d1,d1
                lsl.w   #3,d1
                or.w    d1,d4
                or.w    d0,d6
                move.w  d4,6(a0)							; update in object data
                move.w  d6,14(a0)

;						  01234567890123456789012345678912
				lsl.l	#8,d2
				move.l	(a0),d0
				and.l	#%00000000000000000000011111111111,d0	; clear existing address
				or.l	d2,d0

				move.l	d0,(a0)								; update object GFX pointer
				
               rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; set object pointed to by (a0) to new x/y position
;;
;;
;; a0=object list data
;; d0=x
;; d1=y
				
setup_object_xy:
			tst.w ntsc_flag
			bpl.s	.offsdone
			add.w	#20,d1


.offsdone:
				and.w	#%111111111111,d0
				and.w	#%1111111111,d1
				move.w  6(a0),d4                			; get y-pos
                and.w   #$c007,d4
                move.w  14(a0),d6               			; get x-pos
                and.w   #$f000,d6
                add.w   d1,d1
                lsl.w   #3,d1
                or.w    d1,d4
                or.w    d0,d6
                move.w  d4,6(a0)							; update in object data
                move.w  d6,14(a0)
				rts

				
		include "_INITVID.S"					; init video system
		include "_JOYPAD.S"
		include "_AUDIO.S"

		.phrase
Init_music:     jsr     musicplayer
				move.l	#150,d0
                jsr     musicplayer+$14              ; mid range volume
                move.l	#240,d0
                jsr     musicplayer+$18
				move.l	#module,a0
				jsr     musicplayer+4
				rts		
				
aww:		incbin "SAMPLES/aww.raw"
ooh:		incbin "SAMPLES/ooh.raw"
yeah:		incbin "SAMPLES/yeah.raw"
gling:		incbin "SAMPLES/gling.raw"
droptin:	incbin "SAMPLES/droptin.raw"
				
			.phrase
tetwell:	incbin "bitmaps/well.j16"
			.phrase
		
wellpic:	dc.w	0
			incbin "bitmaps/tetwell.pal"
			incbin "bitmaps/tetwell.jag"
score_pic:	dc.w	0
			incbin "bitmaps/scores_2.pal"
			incbin "bitmaps/scores_2.jag"
copyrite:	dc.w	0
			incbin "bitmaps/copyrite.pal"
			.dphrase
copybitmap:	incbin "bitmaps/copyrite.jag"
			.dphrase
scoremask:	
			.rept	108*200
			dc.w 	0
			.endr
			
			.phrase
webboxgfx:	incbin "bitmaps/webcode.j16"
			.phrase
			
webgfx:		
			.rept	40*8
			dc.b	0
			.endr
			
			.phrase
module:		incbin "music/beebris.mod"
			even
			
			.dphrase
backdrop:	incbin "bitmaps/grad.jag"
			.phrase
newtris:	incbin 	"bitmaps/newtris2.j16"
			.phrase

bot1:	dc.l 0
bot2:	dc.l 0

			include "intro.s"

			.bss
			.dphrase
screen_obj:	ds.l	1
lowborder_obj:	ds.l	1
backdrop_obj:	ds.l	1
newtris_obj:	ds.l	1
scoremask_obj:	ds.l	1
well_obj:		ds.l	1
web_obj:		ds.l	1
webbox_obj:		ds.l	1

ntsc_flag:		.ds.w	1

a_hdb:          .ds.w   1
a_hde:          .ds.w   1
a_vdb:          .ds.w   1
a_vde:          .ds.w   1
awidth:          .ds.w   1
aheight:         .ds.w   1
ticks:          .ds.l   1 	
			.dphrase
			ds.b	$2000
lowscreen:	ds.b	$10000
hiscreen:	ds.b	$10000	

scr_ram_end:
